<%@ page import = "database.*,entities.Device" %>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
	<title>Insert title here</title>
</head>
<body>
	<%
	Device[] mydevices = DeviceQueries.getAllDevices();
//string representation of array.
	String deviceString = Device.arrayToString(mydevices);
//out.println(description);
//out.println(hardware);
	%>
	<script src = "../javascript/nhpup_1.1.js"></script>
	<script type=text/javascript>
//gets variables for database data
var devices = makeDeviceArray();
//get all the option buttons
//var options = document.getElementsByClassName('checkboxes');
var hardwareOptions = document.getElementsByClassName('hw-data-type');
var softwareOptions = document.getElementsByClassName('sw-data-type');
//options[0].addEventListener('click', showAll);
for(var a = 0; a < hardwareOptions.length; a++){
	hardwareOptions[a].addEventListener('click', refresh);
}
for(var a = 0; a < softwareOptions.length; a++){
	softwareOptions[a].addEventListener('click', refresh);
}
// searchbar listener
var searchbar = document.getElementsByName('searchBar');
searchbar[0].onkeyup = refresh;
showAll();
function showAll(){
	var html = '';
	var part1 = "nhpup.popup('";
    var part2 = "');"
	for(var i = 0; i < devices.length; i++){
		html += '<a class = "divlink" href = "#" onmouseover = "'+ part1 + 'Hardware type: ' + devices[i].hardware + '<br><br>' + 'Manufacturer: ' + devices[i].manufacturer + '<br><br>' + 'Model: ' + devices[i].model + part2 + '"><div class = "deviceContainer"><div class = "imgContainer"><img src="../imgs/my-icons-collection-devices/png/' + devices[i].hardware + '.png" onerror="this.src=\'../imgs/synchrony-financial-logo-dlpx_1.png\';" class = "device">' + devices[i].name + '</div><div class = "deviceDescp"><p>' + devices[i].description + '</p><div class = "availableAnchor" id = "' + (i) + '"></div></div></div></a><br><br>';
	}
	document.getElementById('devContainer').innerHTML = html;
	var anchors = document.getElementsByClassName('availableAnchor');
	for(var i = 0; i < anchors.length; i++){
		var anchor = anchors[i];
		var id = anchor.getAttribute('id');
		if(devices[id].status != "Available"){
			document.getElementById(id).innerHTML = 'Unavailable';
			id = '#' + id;
			$(id).css({'background-color':'#ff3535'});
		}
		else{
			document.getElementById(id).innerHTML = 'Available';
			id = '#' + id;
			$(id).css({'background-color':'#1fe07f'});
		}
	}
}
function refresh() {
	var filteredDevices = fuzzyFilter(applyFilter());
	show(filteredDevices);
}
function show(deviceArray){
	var html = '';
	var part1 = "nhpup.popup('";
    var part2 = "');"
	for (var i = 0; i < deviceArray.length; i++) 
	{
		html += '<div onmouseover = "'+ part1 + 'Hardware type: ' + deviceArray[i].hardware + '<br><br>' + 'Manufacturer: ' + deviceArray[i].manufacturer + '<br><br>' + 'Model: ' + deviceArray[i].model + part2 + '" class = "deviceContainer"><a class = "divlink" href = "#"><div class = "imgContainer"><img src="../imgs/my-icons-collection-devices/png/' + deviceArray[i].hardware + '.png" onerror="this.src=\'../imgs/synchrony-financial-logo-dlpx_1.png\';" class = "device">' + deviceArray[i].name + '</div><div class = "deviceDescp"><p>' + deviceArray[i].description + '</p><div class = "availableAnchor" id = "' + (deviceArray[i].id) + '"></div></div></a></div><br><br>'
	}
	document.getElementById('devContainer').innerHTML = html;
	var anchors = document.getElementsByClassName('availableAnchor');
	for(var i = 0; i < anchors.length; i++){
		var anchor = anchors[i];
		var id = anchor.getAttribute('id');
		if(devices[id-1].status != "Available"){
			document.getElementById(id).innerHTML = 'Unavailable';
			id = '#' + id;
			$(id).css({'background-color':'#ff3535'});
		}
		else{
			document.getElementById(id).innerHTML = 'Available';
			id = '#' + id;
			$(id).css({'background-color':'#1fe07f'});
		}
	}
}
function applyFilter() {
	var filteredDevices = new Array();
	var activeHOptions = [];
	var activeSOptions = [];
	for(var i = 0; i < hardwareOptions.length; i++) {
		if (hardwareOptions[i].checked == true) {
			activeHOptions.push(hardwareOptions[i].getAttribute("data-type"));
		}
	}
	for(var i = 0; i < softwareOptions.length; i++) {
		if (softwareOptions[i].checked == true) {
			activeSOptions.push(softwareOptions[i].getAttribute("data-type"));
		}
	}
	for(var i = 0; i < devices.length; i++){
		var hardwareMatch = false;
		var softwareMatch = false;
		for(var j = 0; j < activeHOptions.length; j++) {
			if (activeHOptions[j] == devices[i].hardware){
				hardwareMatch = true;
			}
			// now we must handle the 'other' case
			// there is no 'other' catagory, so if that is the option selected we must make sure
			// that the device in question is not one of the categories we DO have options for
			if(activeHOptions[j] === 'Other')
			{
				var othermatch = true;
				for (var k = 0; k < hardwareOptions.length; k++) {
					if(devices[i].hardware == hardwareOptions[k].getAttribute('data-type'))
						othermatch = false;
				}
				if(othermatch) hardwareMatch = true;
			}
		}
		if (activeHOptions.length == 0) {
			hardwareMatch = true;
		}
		for(var j = 0; j < activeSOptions.length; j++) {
			if (activeSOptions[j] == devices[i].manufacturer){
				softwareMatch = true;
			}
			// now we must handle the 'other' case
			// there is no 'other' catagory, so if that is the option selected we must make sure
			// that the device in question is not one of the categories we DO have options for
			if(activeSOptions[j] === 'Other')
			{
				var othermatch = true;
				for (var k = 0; k < softwareOptions.length; k++) {
					if(devices[i].manufacturer == softwareOptions[k].getAttribute('data-type'))
						othermatch = false;
				}
				if(othermatch) softwareMatch = true;
			}
		}
		if (activeSOptions.length == 0) {
			softwareMatch = true;
		}
		if(hardwareMatch && softwareMatch)
		{
			filteredDevices.push(devices[i]);
		}
	}
	return filteredDevices;
}
function fuzzyFilter(deviceList) {
	var searchText = document.getElementsByName('searchBar')[0].value;
	var options = {
		pre: '<b>',
		post: '</b>',
		extract: function(arg) {return arg.name;}
	}
	var fuzzyResults = fuzzy.filter(searchText, deviceList, options);
	// this returns a filtered array of objects with attributes 'index', 'original', 'score', and 'string'
	// I am interested in the 'original' attribute, which is the relevant object exactly as it was submitted,
	// and the 'string' attribute, which is the attribute that was compared against with matching characters conveniantly bolded
	var results = new Array(fuzzyResults.length);
	// so I'm going to rebuild a filtered device array in the same format as we've been using,
	// substituting the 'name' attribute with the 'string' attribute returned by fuzzy
	for (var i = 0; i < fuzzyResults.length; i++) {
		results[i] = {
			name:fuzzyResults[i].string, //This one is being replaced
			id:fuzzyResults[i].original.id,
			description:fuzzyResults[i].original.description,
			hardware:fuzzyResults[i].original.hardware,
			status:fuzzyResults[i].original.status,
			model:fuzzyResults[i].original.model,
			manufacturer:fuzzyResults[i].original.manufacturer,
		};
	}
	return results;
}
function makeDeviceArray(){
	window.json = '<%=deviceString%>';
	return JSON.parse(window.json);
}
</script>
<script src="../javascript/lib/fuzzy.js"></script>
</body>
</html>