<%@ page import = "database.*,entities.Device" %>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<title>Insert title here</title>
</head>
<body>
<%
Device[] mydevices = DeviceQueries.getAvailableDevices();
//string representation of array.
String deviceString = Device.arrayToString(mydevices);
deviceString = deviceString.replace("'","\\'");
//out.println(description);
//out.println(hardware);
%>
<script src = "../javascript/nhpup_1.1.js"></script>
<script type=text/javascript>
//gets variables for database data
var devices = makeDeviceArray();
//get all the option buttons
var hardwareOptions = document.getElementsByClassName('hw-data-type');
var softwareOptions = document.getElementsByClassName('sw-data-type');
//add event listeners to the options in the left sidebar
for(var a = 0; a < hardwareOptions.length; a++){
	hardwareOptions[a].addEventListener('click', refresh);
}
for(var a = 0; a < softwareOptions.length; a++){
	softwareOptions[a].addEventListener('click', refresh);
}
showAll();
// searchbar listener
var searchbar = document.getElementsByName('searchBar');
searchbar[0].onkeyup = refresh;
// populate page with all devices by default
show(devices);
function refresh() {
	show(fuzzyFilter(filter(devices)));
}

function showAll(){
	var html = '';
	var part1 = "nhpup.popup('";
    var part2 = "');"
	for(var i = 0; i < devices.length; i++){
		html += '<a class = "divlink" href = "#" onmouseover = "'+ part1 + 'Hardware type: ' + devices[i].hardware + '<br><br>' + 'Manufacturer: ' + devices[i].manufacturer + '<br><br>' + 'Model: ' + devices[i].model + part2 + '"><div class = "deviceContainer"><div class = "imgContainer"><img src="../imgs/my-icons-collection-devices/png/' + devices[i].hardware + '.png" onerror="this.src=\'../imgs/synchrony-financial-logo-dlpx_1.png\';" class = "device">' + devices[i].name + '</div><div class = "deviceDescp"><p>' + devices[i].description + '</p><div class = "availableAnchor" id = "' + (i) + '"></div></div></div></a><br><br>';
	}
    
    if(html.localeCompare("")==0)
		html += "<p>There are no devices with the search criteria: " + this.textContent + "</p>";
    
	document.getElementById('devContainer').innerHTML = html;
	
	var requestbuttons = document.getElementsByClassName('requestbutton');
	for(var i = 0; i < requestbuttons.length; i++) {
		requestbuttons[i].addEventListener('click',addToCart);
	}
}
//when an option is selected, show a new list of devices based on what the user asked for
function show(deviceArray){
	// var type = this.getAttribute('data-type');
	var html = '';
	var part1 = "nhpup.popup('";
    var part2 = "');"
	for (var i = 0; i < deviceArray.length; i++) {
		html += '<a class = "divlink" href = "#" onmouseover = "' + part1 + 'Hardware type: ' + deviceArray[i].hardware + '<br><br>' + 'Manufacturer: ' + deviceArray[i].manufacturer + '<br><br>' + 'Model: ' + deviceArray[i].model + part2 + '"><div class = "deviceContainer"><div class = "imgContainer"><img src="../imgs/my-icons-collection-devices/png/' + deviceArray[i].hardware + '.png" onerror="this.src=\'../imgs/synchrony-financial-logo-dlpx_1.png\';" class = "device">' + deviceArray[i].name + '</div><div class = "deviceDescp"><p>' + deviceArray[i].description + '</p><button class = "requestbutton" id = "button' + (deviceArray[i].id) + '" type="button">Order device</button></div></div></a><br><br>'
	}
	
	if(html.localeCompare("")==0)
		html += "<p>There are no devices with the search criteria: " + this.textContent + "</p>";
	
	//add to HTML page
	document.getElementById('devContainer').innerHTML = html;
	
	//now we need to add event listeners to all the request buttons
	var requestbuttons = document.getElementsByClassName('requestbutton');
	for(var i = 0; i < requestbuttons.length; i++) {
		requestbuttons[i].addEventListener('click',addToCart);
	}
}
function filter(deviceArray) {
	var filteredArray = new Array();
	var activeHOptions = [];
	var activeSOptions = [];
	for(var i = 0; i < hardwareOptions.length; i++) {
		if (hardwareOptions[i].checked == true) {
			activeHOptions.push(hardwareOptions[i].getAttribute("data-type"));
		}
	}
	for(var i = 0; i < softwareOptions.length; i++) {
		if (softwareOptions[i].checked == true) {
			activeSOptions.push(softwareOptions[i].getAttribute("data-type"));
		}
	}
	//iterate through the hardcoded device DB and select all the ones that match the selected option
	for(var i = 0; i < deviceArray.length; i++){
		var hardwareMatch = false;
		var softwareMatch = false;
		for(var j = 0; j < activeHOptions.length; j++) {
			if (activeHOptions[j] == deviceArray[i].hardware){
				hardwareMatch = true;
			}
			// now we must handle the 'other' case
			// there is no 'other' catagory, so if that is the option selected we must make sure
			// that the device in question is not one of the categories we DO have options for
			if(activeHOptions[j] === 'Other')
			{
				var othermatch = true;
				for (var k = 0; k < hardwareOptions.length; k++) {
					if(devices[i].hardware == hardwareOptions[k].getAttribute('data-type'))
						othermatch = false;
				}
				if(othermatch) hardwareMatch = true;
			}
		}
		if (activeHOptions.length == 0) {
			hardwareMatch = true;
		}
		for(var j = 0; j < activeSOptions.length; j++) {
			if (activeSOptions[j] == devices[i].manufacturer){
				softwareMatch = true;
			}
		// now we must handle the 'other' case
		// there is no 'other' catagory, so if that is the option selected we must make sure
		// that the device in question is not one of the categories we DO have options for
			if(activeSOptions[j] === 'Other')
			{
				var othermatch = true;
				for (var k = 0; k < softwareOptions.length; k++) {
					if(devices[i].manufacturer == softwareOptions[k].getAttribute('data-type'))
						othermatch = false;
				}
				if(othermatch) softwareMatch = true;
			}
		}
		if (activeSOptions.length == 0) {
			softwareMatch = true;
		}
		if(hardwareMatch == true && softwareMatch == true)
			filteredArray.push(deviceArray[i]);
	}
	return filteredArray;
}
function fuzzyFilter(deviceArray) {
	var searchText = document.getElementsByName('searchBar')[0].value;
	var options = {
		pre: '<b>',
		post: '</b>',
		extract: function(arg) {return arg.name;}
	}
	var fuzzyResults = fuzzy.filter(searchText, deviceArray, options);
	// this returns a filtered array of objects with attributes 'index', 'original', 'score', and 'string'
	// I am interested in the 'original' attribute, which is the relevant object exactly as it was submitted,
	// and the 'string' attribute, which is the attribute that was compared against with matching characters conveniantly bolded
	var results = new Array(fuzzyResults.length);
	// so I'm going to rebuild a filtered device array in the same format as we've been using,
	// substituting the 'name' attribute with the 'string' attribute returned by fuzzy
	for (var i = 0; i < fuzzyResults.length; i++) {
		results[i] = {
			name:fuzzyResults[i].string, //This one is being replaced
			id:fuzzyResults[i].original.id,
			description:fuzzyResults[i].original.description,
			hardware:fuzzyResults[i].original.hardware,
			status:fuzzyResults[i].original.status,
			model:fuzzyResults[i].original.model,
			manufacturer:fuzzyResults[i].original.manufacturer,
		};
	}
	return results;
}
function addToCart(){
	var id = this.getAttribute('id');
	id = id.replace(/[^0-9\.]/g,'');
	if(!inCart(id)){								//if not in the cart
		var cart = getCartItems();					//this is an array
		id = parseInt(id,10);	//this gets just the numerical value from the id!
		var device = getDevice(id);
		cart.push(device);								//push to bottom of cart
		localStorage.setItem('cart', JSON.stringify(cart));
		$('#added').fadeIn(1000);
		$('#added').fadeIn(1000);
    	$('#added').fadeOut(1000);
	}
	else{
		$('#already').fadeIn(1000);
		$('#already').fadeIn(1000);
    	$('#already').fadeOut(1000);
	}
}
function inCart(id){
	var cart = getCartItems();
	if(cart.length == 0)	//if nothing's in the cart 
		return 0;
	else{ 					//something is in the cart
		for(var i = 0; i < cart.length; i++){
			if(id.localeCompare(cart[i].id) == 0)
				return 1;
		}
	}
	return 0;	
}
function getCartItems(){
	//initiate array for them
    var cart = new Array;
	//get them from local age
    var cart_str = localStorage.getItem('cart');
	//if there is at least one object already we need to convert it from JSON to string
    if (cart_str !== null && cart_str !== "") {
        cart = JSON.parse(cart_str);
    }
    return cart;
}
function makeDeviceArray(){
	window.json = '<%=deviceString%>';
	return JSON.parse(window.json);
}
function getDevice(id){
	for(var i = 0; i < devices.length; i++){
		if(id == devices[i].id)
			return devices[i];
	}
}
//this code allows a message to appear that indicates that the item was successfully placed in the shopping cart.
</script>
<script src="../javascript/lib/fuzzy.js"></script>
</body>
</html>