<%@ page import="database.*,entities.*"%>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
	pageEncoding="ISO-8859-1"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
	<meta name="description" content="">
	<meta name="author" content="">

	<title>Synchrony Financial</title>

	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
	<!-- Latest compiled and minified CSS -->
	<link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/bootstrap-table/1.11.1/bootstrap-table.min.css">
	<link rel="stylesheet" type="text/css" href="../../css/stylesheet.css">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
	<!-- Latest compiled and minified JavaScript -->
	<script src="//cdnjs.cloudflare.com/ajax/libs/bootstrap-table/1.11.1/bootstrap-table.min.js"></script>
	<!-- Latest compiled and minified Locales -->
	<script src="//cdnjs.cloudflare.com/ajax/libs/bootstrap-table/1.11.1/locale/bootstrap-table-zh-CN.min.js"></script>	
	<link rel="shortcut icon" href="../../imgs/synchrony-financial-logo-dlpx_1.ico">
	<style>

		.table {
			background-color: #E9EAEB;
		}

		tr.entry {
			cursor: pointer;
		}

		body{
			overflow: visible;
		}

		div.displayDevice{
			padding-right: 30px;
			padding-bottom: 30px;
		}

		.form-control{
			margin: auto;
			text-align: center;
		}

		div.form-group{
			display: inline-block;
			vertical-align: top;
		}
	</style>
</head>

<body>
	<nav class="navbar navbar-inverse navbar-fixed-top" id="navbaruniversal">
		<%@ include file="../components/adminnavbar.jsp"%>
	</nav>

	<div class="col-sm-3 col-md-2 sidebar">
		<%@ include file="../components/adminsidebar.jsp" %>
	</div>

	<!-- Main display area. -->
	<div class="displayDevice">
		<h2>Administrator Management Settings</h2>
		<table id = "tabledisplay" class="table table-bordered table-hover" data-toggle="table" data-sort-name="name" data-sort-order="asc">
			<thead>
				<tr>
					<th style = "width: 20px;" data-name = "name" data-sortable = "true">Name</th>
					<th data-name = "sso" data-sortable = "true">SSO</th>
					<th data-name = "finger" data-sortable = "true">Fingerprint Registered?</th>
				</tr>
			</thead>
			<tbody id="tablemainbody">
			</tbody>
		</table>		
		<button style = "margin-top: 15px;" class = "btn btn-primary" id="addbutton">Add Admin</button>
	</div>

	<!-- Modal for adding a new admin. -->
	<div id="addAdminModal" class="modal">
		<div class="modal-content">
			<div class="modal-head">
				<span id="closeAddForm" class="close">&times;</span>
				<h4>Input New Admin Information</h4>
			</div>
			<div class="modal-body">
				<form name="addAdminModal" action="../redirect/newadminRedirect.jsp" method="post">
					<div class="form-group">
						<label for="SSO">SSO</label>
						<input type="text" class="form-control" name="adminID" pattern="[0-9]{9}" placeholder="xxxxxxxxx" style="width: 100px;" required>
					</div>
					<div class="form-group">
						<label for="name">Name</label>
						<input type="text" class="form-control" name="name" placeholder="Johnny Appleseed" style="width: 150px;" required>
					</div>
					<div class="form-group">
						<label for="email">Email</label>
						<input type="email" class="form-control" name="email" placeholder="email@email.com" style="width: 200px;" required>
					</div>
					<br>
					<button type="submit" class="btn btn-primary" name="add">Submit</button>
				</form>
			</div>
		</div>
	</div>

	<!-- Modal for removing an admin -->
	<div id="removeAdminModal" class="modal">
		<div class="modal-content">
			<div class="modal-head">
				<span id="closeRemoveForm" class="close">&times;</span>
				<h4>View Admin Below</h4>
			</div><br>
			<div class="modal-body">
				<form ACTION = "../redirect/newadminRedirect.jsp" METHOD = "POST">
					<table style = "margin: 0 auto; width: auto;" class="table table-bordered table-hover">
						<thead>
							<tr>
								<th>Name</th>
								<th>SSO</th>
								<th>Fingerprint Registered?</th>
							</tr>
						</thead>
						<tbody id="tablemodal">
						</tbody>
					</table>
					<button id = "thedeletebutton" type = "submit" name = "delete" value = "delete" class="btn btn-primary" style = "margin-top: 15px;">Delete Admin</button>
					<input type="text" id = "admindeleteid" name="AdminID" style="display: none;" />
				</form>
			</div>
		</div>
	</div>
</body>
<%
	Admin[] admins = AdminQueries.getAllAdmins();
	String adminString = Admin.arrayToString(admins);
	adminString = adminString.replace("'", "\\'");
%>

<script type=text/javascript>


  var admins = makeAdminArray();
  populateAdmin();
  var editAdmins = new Array;
	
  // Clicking x on modal forms
  $("#closeRemoveForm").click(closeRemoveModal);
  $("#closeAddForm").click(closeAddModal);
  
  // Open form to make new admin.  
  $("#addbutton").click(openAddModal);
  
  // Click esc key
  window.onkeydown = function(e){if (e.keyCode == 27){closeRemoveModal();closeAddModal();}}
  
  // Closing out the modal when clicking outside of the modal.
  window.onclick = function(event) { 
  	var modal = document.getElementById('addAdminModal');
  	var modal2 = document.getElementById('removeAdminModal');
  	if(event.target == modal || event.target == modal2){modal.style.display = "none";modal2.style.display="none";}
  }
  
  // Set up table record event listeners
  $('#tabledisplay').bootstrapTable({onClickRow: function(row,$element){
  	var id = $element[0].getAttribute('id');
  	var html = "<tr><td>" + admins[id].name + "</td><td>" + admins[id].id + "</td><td>" + admins[id].finger + "</td><tr>";
  	document.getElementById("tablemodal").innerHTML = html;
  	$("#admindeleteid").val(admins[id].id);
  	
  	// If an admin has a fingerprint registered, their deletion should be restricted.
  	if(admins[id].finger.localeCompare("Yes") == 0){
  		$('#thedeletebutton').attr('disabled',true);
  		$('#thedeletebutton').attr('title','You have to unregister their fingerprint to delete.');
  	}
  	else{
  		$('#thedeletebutton').removeAttr('disabled');
  		$('#thedeletebutton').removeAttr('title');
  	}
  	// Also shouldn't be able to delete yourself!!
  	if(<%=navsso%> == admins[id].id){
  		$('#thedeletebutton').attr('disabled',true);
  		$('#thedeletebutton').attr('title','I highly advise against deleting yourself.');
  	}
  	
  	$("#removeAdminModal").show();
  }});

  /*
	This function populates the webpage with admin information gathered from the server.
  */
  function populateAdmin()
  {
  	var html = "";
  	for(var i = 0; i < admins.length; i++)
  	{
  		html += "<tr class = 'entry' id = '" + i + "'><td>" + admins[i].name + "</td><td>" + admins[i].id + "</td><td>" + admins[i].finger + "</td></tr>";
  	}
  	document.getElementById("tablemainbody").innerHTML = html;
  }
  
  /*
	This function makes an array of admins given from the server.
  */
  function makeAdminArray()
  {
  	window.json = '<%=adminString%>';
  	return JSON.parse(window.json);
  }

  /*
    Opens up the add modal.
  */
  function openAddModal() {
   	$("#addAdminModal").show();
  }

  /*
	This function closes the remove modal.
  */
  function closeRemoveModal(){
	$("#removeAdminModal").hide();
  }

  /*
	This function closes the add modal.
  */
  function closeAddModal(){
	$("#addAdminModal").hide();
  }
</script>
</html>

