<%@ page import = "database.*,entities.Device" %>
<%@ page import = "java.sql.*" %>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
    pageEncoding="ISO-8859-1"%>
<%@ page import = "java.security.MessageDigest" %>
<%@ page import = "java.security.NoSuchAlgorithmException" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
  <meta name="description" content="">
  <meta name="author" content="">

  <title>Synchrony Financial</title>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
  <link rel = "stylesheet" type = "text/css" href = "../../css/stylesheet.css">
  <link rel = "shortcut icon" href = "../../imgs/synchrony-financial-logo-dlpx_1.ico">
  <nav class="navbar navbar-inverse navbar-fixed-top" id = "navbaruniversal">
    <%@ include file="../components/navbar.jsp"%>
  </nav>
</head>
<body>
  <h2>Redirect Page</h2>
  <p>You shouldn't be seeing this page :)</p>

<%
/*
	We follow into this "if" statement if the password change form was submitted.
*/
if(request.getParameter("password") != null){
  /*
  	Gathering form information that the user submitted.
  */
  String old = request.getParameter("old");
  String newpass = request.getParameter("new");
  String confirm = request.getParameter("confirm");
  String generatedOldPass = null;
  
  /*
  	This uses MD5 to hash the old password the user entered in, so it can be compared against what is in the DB.
  */
  try {
  	MessageDigest md = MessageDigest.getInstance("MD5");
  	md.update(old.getBytes());
  	byte[] bytes = md.digest();
  	StringBuilder sb = new StringBuilder();
  	for(int i = 0; i<bytes.length; i++)
  		sb.append(Integer.toString((bytes[i] & 0xff) + 0x100, 16).substring(1));
		generatedOldPass = sb.toString();
 	 }
  catch (NoSuchAlgorithmException e){
  }
  
  /*
  	Make a connection to the database, and get the user that is attempting to change their password.
  */
  String generatedPass = null;
  String generatedPincode = null;
  String database = "jdbc:mysql://us-cdbr-iron-east-04.cleardb.net/ad_15a989204c2ff8a?user=b372dfe7409692&password=74f6e317";
  String user = "b372dfe7409692";
  String password = "74f6e317";
  System.getenv("VCAP_SERVICES");
  Class.forName("com.mysql.jdbc.Driver");
  Connection connection;
  Statement stmt;
  for(;;){
	  try{
		  connection = DriverManager.getConnection(database, user, password);
		  break;
	  }
	  catch(SQLException e){
		  Thread.sleep(1);
	  }
  }
  for(;;){
	  try{
		  stmt = connection.createStatement();
		  break;
	  }
	  catch(SQLException e){
		  Thread.sleep(1);
  	  }
  }
  ResultSet result;
  String query = "select * FROM admin where Admin_ID='" + navsso + "' AND Password='" + generatedOldPass + "'";
  result = stmt.executeQuery(query);
  System.out.println("Executing query: "+query);
  /*
  	If the old password is correct, then we can continue to change the password.
  */
  if(result.next()){
    /*
    	We check to see that the password is actually changing (not the same as the old one) and that the new & confirmed password are equal to one another.
    */
  	if (!old.equals(newpass) && newpass.equals(confirm)){
  		/*
  			We take the new password, and generate a hash for it.
  		*/
  		try {
			MessageDigest md2 = MessageDigest.getInstance("MD5");
			md2.update(newpass.getBytes());
			byte[] bytes = md2.digest();
			StringBuilder sb = new StringBuilder();
			for(int i = 0; i<bytes.length; i++)
				sb.append(Integer.toString((bytes[i] & 0xff) + 0x100, 16).substring(1));
				generatedPass = sb.toString();
		}
		catch (NoSuchAlgorithmException e){
		}
		
		/*
			Update the password in the database.
		*/
  		stmt.executeUpdate("UPDATE admin SET Password = \"" + generatedPass + "\" WHERE Admin_ID = " + navsso);
  		stmt.close();
  		connection.close();
  		response.sendRedirect("../administration/admin.jsp");
  		return;
  	}
  	/*
  		If the password doesn't change, or if the new ones don't match, we go to the try again page.
  	*/
  	else{
  		stmt.close();
  		connection.close();
  		response.sendRedirect("../administration/adminpasswordsettingtryagain.jsp");
  		return;
  	}
  }
  /*
  	If the old password was incorrect, we do not want to update it, and we want to send them to a "try again" page.
  */
  else{
  	stmt.close();
  	connection.close();
  	response.sendRedirect("../administration/adminpasswordsettingtryagain.jsp");
  	return;
  }
}

/*
	We follow into this "if" statement if the pincode change form was submitted.
*/
if(request.getParameter("pincode") != null){
	String pincode = request.getParameter("pincode");
	
  /*
  	Make a connection to the database, and get the user that is attempting to change their pincode.
  */
  String generatedPass = null;
  String generatedPincode = null;
  String database = "jdbc:mysql://us-cdbr-iron-east-04.cleardb.net/ad_15a989204c2ff8a?user=b372dfe7409692&password=74f6e317";
  String user = "b372dfe7409692";
  String password = "74f6e317";
  System.getenv("VCAP_SERVICES");
  Class.forName("com.mysql.jdbc.Driver");
  Connection connection = DriverManager.getConnection(database, user, password);
  Statement stmt = connection.createStatement();
  ResultSet result;
  result = stmt.executeQuery("select * FROM admin where Admin_ID='" + navsso + "'");
  
  /*
  	We want to make sure the pincode is 4 digits, and that the pincode is actually numerical.
  */
  if(pincode.length() == 4 && AdminQueries.pincodeInt(pincode)){
	    /*
	    	Hash the pincode that we got from the user.
	    */
	  	try {
			MessageDigest md3 = MessageDigest.getInstance("MD5");
			md3.update(pincode.getBytes());
			byte[] bytes = md3.digest();
			StringBuilder sb = new StringBuilder();
			for(int i = 0; i<bytes.length; i++)
				sb.append(Integer.toString((bytes[i] & 0xff) + 0x100, 16).substring(1));
				generatedPincode = sb.toString();
		}
		catch (NoSuchAlgorithmException e){
		}
		/*
			Update the pincode in the database.
		*/
	  	stmt.executeUpdate("UPDATE admin SET Pincode = \"" + generatedPincode + "\" WHERE Admin_ID = " + navsso);
	  	stmt.close();
	  	connection.close();
	  	response.sendRedirect("../administration/admin.jsp");
	  	return;
  }
  /*
  	Pincode isn't 4 long, OR pincode is not numerical
  */
  else{
	  	stmt.close();
	  	connection.close();
	  	response.sendRedirect("../administration/adminpasswordsettingtryagain.jsp");
	  	return;
  }
}
%>
</body>
</html> 