<%@ page import = "database.*,entities.Device" %>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
pageEncoding="ISO-8859-1"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
  <meta name="description" content="">
  <meta name="author" content="">

  <title>Innovation Hub</title>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
  <link rel = "stylesheet" type = "text/css" href = "../css/stylesheet.css">
  <link rel = "shortcut icon" href = "../imgs/synchrony-financial-logo-dlpx_1.ico">
  <style>
    div.deviceContainer{
      border: solid; 
      border-width: thin; 
      padding: 15px;
      background-color: #E9EAEB;
      display: inline-block;
      cursor: pointer;
      position: relative;
    }

    div.imgContainer{
      display: inline-block; 
      text-align: center;
    }

    div.returnButtonContainer{
      text-align: right;
    }

    img.device{
      display: block;
    }
    div.returnConfirm{
      display: none;
      top: 50%;
      left: 50%;
      position: fixed;
      width: 155px;
      height: 85px;
      line-height: 85px;
      text-align: center;
      background-color: #FBC600;
      border: solid;
      border-color: #3B3C43;
      border-radius: 5px;
    }
    div.deviceInfo{
      display: inline-block; 
      vertical-align: top;
      padding-top: 15px; 
      padding-left: 20px;
      width: 200px; 
    }
    tbody{
      text-align: left;
    }
    input.deviceCheckbox{
    	position: absolute;
    	left: 0px;
    	bottom: 0px;
    	height: 20px;
    	width: 20px;
    }
    #pup{
      background-color: #E9EAEB;
      border: solid;
      text-align: center;
      padding: 10px;
    }
  </style>
</head>
<body>
  <nav class="navbar navbar-inverse navbar-fixed-top" id = "navbaruniversal">
    <%@ include file="components/navbar.jsp"%>
  </nav>
  <!-- Modal for transaction review. -->
  <div id="orderInfoModal" class="modal">
    <div class="modal-content">
      <div class="modal-head">
        <span id="closeOrderForm" class="close">&times;</span>
        <h4>Please Review Your Return Choices</h4>
      </div><br>
      <div class="modal-body">
        <!-- Table to display review data. -->
        <table class="table table-bordered table-hover" id = "tabledisplay">
         <thread>
          <tr>
           <th>Device Name</th>
           <th>Model</th>
           <th>Hardware</th>
         </tr>
       </thread>
       <tbody id = "tablebody">
       </tbody>
     </table>
     <form ACTION = "returnComplete.jsp" METHOD = "POST">
      <input type = "text" id = "deviceArray" style = "display: none;" name = "devicesToReturn"></input>
      <button type = "submit" class = "btn btn-primary">Submit</button>
    </form>
  </div>
</div>
</div>
<!-- Sidebar. -->
<div class="col-sm-3 col-md-2 sidebar">
  <ul class="nav nav-sidebar">
    <h4>Return Page Options</h4>
    <li class = "option" id = "returnbutton"><a href="#">Return Selected</a></li>
    <li class = "option" id = "returnall"><a href="#">Return All</a></li>
  </ul>
</div>
<div class="displayDevice">
  <h2>Devices to Be Returned</h2>
  <!-- Device information boxes placed here. -->
  <div id = "devContainer">
  </div>
</div>

<%
Device[] mydevices = DeviceQueries.getUserDevices(navsso);
//string representation of array.
String deviceString = Device.arrayToString(mydevices);
%>
<script src = "../javascript/nhpup_1.1.js"></script>
<script type=text/javascript>

//JSON representation of array.
var devices = makeDeviceArray();
//Devices to be returned.
var toReturn = [];

//Populates devices into device divs
populateDeviceList();

//Event listeners for divs.
$('div.deviceContainer').click(fireCheck);
$('input.deviceCheckbox').click(selectBox);
//Event listener for return selected.
$('#returnbutton').click(returnDevice);
//Event listener for return all.
$('#returnall').click(returnAll);
//Event listener for modal x button.
$('#closeOrderForm').click(hidePopup);
//Event listener exits modal when esc key pressed.
window.onkeydown = function(e){if (e.keyCode == 27){hidePopup();}}
//Event listener exits modal when click outside modal.
window.onclick = function(e){var modal = document.getElementById('orderInfoModal'); if(e.target == modal) hidePopup();}

//Make JSON from Java of retrieved devices.
function makeDeviceArray(){
	window.json = '<%=deviceString%>';
	return JSON.parse(window.json);
}

//Event listener for div changes color and adds/removes from selected to return.
function fireCheck(){
	//get device id
	var id = this.getAttribute('data-num');
	//create jquery strings
	var query = 'input[data-num="'+id+'"]';
	var query2 = 'div[data-num="'+id+'"]';
	//check to see if checkbox is checked
	var checked = $(query).prop('checked');
	//if so...
	if(checked === true){
		//uncheck box
		$(query).prop('checked',false);
		//lighten background color
		$(query2).css("background-color","#E9EAEB");
		//remove from toReturn array
		toReturn.splice(toReturn.indexOf(id),1)
	}
	//if box is unchecked...
	else{
		//check it off
		$(query).prop('checked',true);
		//make background darker
		$(query2).css("background-color","#C2C3C4");
		//add to toReturned array
		toReturn.push(id);
	}
}

//Event listener to undo checkmark so fireCheck() can handle instead.
function selectBox(){
	//get id
	var id = this.getAttribute('data-num');
	//Create query to get checkbox
	var query = 'input[data-num="'+id+'"]';
	//Determine if it's checked
	var checked = $(query).prop('checked');
	//Undo the checkmark in this branch
	if(checked === false){
		$(query).prop('checked',true);
	}
	else{
		$(query).prop('checked',false);
	}
}

//Generates html and writes to 'devContainer' div in JSP
function populateDeviceList(){
	//begin empty html
	var	htmlString="";
	//iterate returned devices
	for (var i = 0; i < devices.length; i++) {
		//get device values
		var id = devices[i].id;
		var name = devices[i].name;
		var hardware = devices[i].hardware;
		var checkout = devices[i].checkout;
		var manufacturer = devices[i].manufacturer;
		var model = devices[i].model;
		
		var part1 = "nhpup.popup('";
	    var part2 = "');"
		//HTML representation in divs
		htmlString+='<a class = "divlink" href = "#" onmouseover = "'+ part1 + 'Hardware type: ' + hardware + '<br><br>' + 'Manufacturer: ' + manufacturer + '<br><br>' + 'Model: ' + model + part2 + '">';
		htmlString+="<div class=\"deviceContainer\" data-num=\"" + i +"\">";
		htmlString+="<input class=\"deviceCheckbox\" type = \"checkbox\" data-num=\"" + i + "\">";
		htmlString+="<div><div class=\"imgContainer\"><img onerror=\"this.src='../imgs/synchrony-financial-logo-dlpx_1.png';\" src=\"../imgs/my-icons-collection-devices/png/";
		htmlString+=hardware;
		htmlString+=".png\" class=\"device\">";
		htmlString+=name;
		htmlString+="</div><div class=\"deviceInfo\"><p>Checked out: "
		htmlString+=checkout;
		htmlString+="</div></p></div></div><br><br>";
	}
	//Handles if no devices are returned
	if(i==0) htmlString+="Couldn't find any devices to return. Why not go order some?";
	
	//Place html in body
	document.getElementById("devContainer").innerHTML = htmlString;
}

//Initiates modal to popup for review
function returnDevice()
{
	var html = "";
	//iterate devices that are to be returned
	for(var i = 0; i < toReturn.length; i++){
		html+= "<tr><td>" + devices[toReturn[i]].name + "</td><td>" + devices[toReturn[i]].model + "</td><td>" + devices[toReturn[i]].hardware + "</td></tr>";
	}
	//place html in body
	document.getElementById("tablebody").innerHTML = html;
	//place input in form
  $('#deviceArray').val(arrayToString(toReturn));
  //show modal
	$('#orderInfoModal').show();
}

//Initiates model to popup for review
function returnAll(){
	var checkboxes = document.getElementsByClassName('deviceCheckbox');
	for(var i = 0; i < checkboxes.length; i++){
		//get id
		var id = checkboxes[i].getAttribute('data-num');
		//Create query to get checkbox
		var query = 'input[data-num="'+id+'"]';
		var query2 = 'div[data-num="'+id+'"]';
		//Determine if it's checked
		var checked = $(query).prop('checked');
		//Check it off
		if(checked === false){
			$(query).prop('checked',true);
			$(query2).css("background-color","#C2C3C4");
			//add to toReturned array
			toReturn.push(id);
		}
	}
	returnDevice();
}

//Call to exit modal
function hidePopup(){
	$('#orderInfoModal').hide();
}

//Turns array to string, which can be submitted on the form when actually returning
//The string will contain the ID's of devices to be returned, and this will be sent to the database!
function arrayToString(array){
  var sb = "[";
  for(var i = 0; i < array.length; i++){
  	//get the return id, go to that index in queried devices, and get that id!
    sb+= devices[array[i]].id;
    if(i != array.length-1)
      sb+=",";
  }
  sb+="]";
  return sb;
}
</script>
</body>
</html>