<%@ page import = "database.*" %>
<%@ page import = "entities.User" %>
<%@ page import = "entities.Location" %>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
pageEncoding="ISO-8859-1"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
  <meta name="description" content="">
  <meta name="author" content="">

  <title>Innovation Hub</title>

  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <link rel = "stylesheet" type = "text/css" href = "../css/stylesheet.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
  <link rel = "shortcut icon" href = "../imgs/synchrony-financial-logo-dlpx_1.ico">

  <style>
    input{
      text-align: center;
    }
    div.ticket{
      background-image: url('../imgs/ticket.png');
      display: inline-block;
      height: 126px;
      width: 240px;
    }

    p.tickettext{
      text-align: center;
      vertical-align: middle;
      line-height: 126px;
    }

    #pup{
      background-color: #E9EAEB;
      border: solid;
      text-align: center;
      padding: 10px;
    }

    input[type=text]{ margin: 0 auto; width: 60%; }

    input[type=tel]{ margin: 0 auto; width: 60%; }
 </style>

</head>

<body>
  <nav class="navbar navbar-inverse navbar-fixed-top" id = "navbaruniversal">
    <%@ include file="components/navbar.jsp"%>
  </nav>
  <div id="orderInfoModal" class="modal">
    <div class="modal-content" style="overflow-y: auto; overflow-x: hidden">
      <div class="modal-head">
        <span id="closeOrderForm" class="close">&times;</span>
        <h4>Please provide additional order information</h4>
      </div>
      <div class="modal-body">
        <form name="orderForm" onsubmit="return submitOrderForm()" action="redirect/orderFormHandler.jsp" method="post">
          <input type="text" name="userID" style = "display: none;"/>
          <input type="text" name="orderAll" style = "display: none;"/>    
          <input type="text" name="deviceIDs" style="display: none;">
          <input type="text" name="deviceNames" style="display: none;">          
          <div class="form-group row">
            <label for="name">Your name</label><br/>
            <input type="text" class="form-control" name="name" placeholder="Name"  required>
          </div>
          <div class="form-group row">
            <label for="phone">Phone Number</label><br/>
            <input type="tel" class="form-control" name="phone" placeholder="xxx-xxx-xxxx" required>
          </div>
          <div class="form-group row">
            <label for="email">Email</label><br/>
            <input type="email" class="form-control" name="email" placeholder="name@org.domain" style="margin: 0 auto; width:60%" required>
          </div>
          <div class="form-group">
            <label for="location_dropdown">Place to ship to</label><br/>
            <select class="form-control" name="location_dropdown" id="dropdown" onchange="forceUpdateLocationMetadata()" style="width:65%; max-height: 80%; text-align: center; vertical-align: center; align-items: center; display: block; position: relative; margin: 0% auto; text-align-last:center; padding:">
            </select>
          </div>
          
          <div class="form-group row" style="display: block; align-items: center;margin: 3% auto;">
            <div class="col-md-6" style="width:50%">
              <div class="form-group row">
                <label for="address">Street Address</label>                        
                <input type="text" onkeyup="forceDropdownCustomLocation" class="form-control" name="address" placeholder="Address" required/>
              </div>
              <div class="form-group row">
                <label for="town">City</label>                            
                <input type="text" onkeyup="forceDropdownCustomLocation" class="form-control" name="town" placeholder="City" required/>
              </div>
            </div>
            <div class="col-md-6" style="width:50%">
              <div class="form-group row">
                <label for="state">State</label>                            
                <select required style = "width: 60%; text-align-last:center;" name = "state" class="form-control">
                  <option value="" disabled selected>Choose State</option>
                  <option value="AL">Alabama</option>
                  <option value="AK">Alaska</option>
                  <option value="AZ">Arizona</option>
                  <option value="AR">Arkansas</option>
                  <option value="CA">California</option>
                  <option value="CO">Colorado</option>
                  <option value="CT">Connecticut</option>
                  <option value="DE">Delaware</option>
                  <option value="DC">District Of Columbia</option>
                  <option value="FL">Florida</option>
                  <option value="GA">Georgia</option>
                  <option value="HI">Hawaii</option>
                  <option value="ID">Idaho</option>
                  <option value="IL">Illinois</option>
                  <option value="IN">Indiana</option>
                  <option value="IA">Iowa</option>
                  <option value="KS">Kansas</option>
                  <option value="KY">Kentucky</option>
                  <option value="LA">Louisiana</option>
                  <option value="ME">Maine</option>
                  <option value="MD">Maryland</option>
                  <option value="MA">Massachusetts</option>
                  <option value="MI">Michigan</option>
                  <option value="MN">Minnesota</option>
                  <option value="MS">Mississippi</option>
                  <option value="MO">Missouri</option>
                  <option value="MT">Montana</option>
                  <option value="NE">Nebraska</option>
                  <option value="NV">Nevada</option>
                  <option value="NH">New Hampshire</option>
                  <option value="NJ">New Jersey</option>
                  <option value="NM">New Mexico</option>
                  <option value="NY">New York</option>
                  <option value="NC">North Carolina</option>
                  <option value="ND">North Dakota</option>
                  <option value="OH">Ohio</option>
                  <option value="OK">Oklahoma</option>
                  <option value="OR">Oregon</option>
                  <option value="PA">Pennsylvania</option>
                  <option value="RI">Rhode Island</option>
                  <option value="SC">South Carolina</option>
                  <option value="SD">South Dakota</option>
                  <option value="TN">Tennessee</option>
                  <option value="TX">Texas</option>
                  <option value="UT">Utah</option>
                  <option value="VT">Vermont</option>
                  <option value="VA">Virginia</option>
                  <option value="WA">Washington</option>
                  <option value="WV">West Virginia</option>
                  <option value="WI">Wisconsin</option>
                  <option value="WY">Wyoming</option>
                </select>
              </div>
              <div class="form-group row">
                <label for="zip">Zip</label>                            
                <input id = "zip" type="text" onkeyup="forceDropdownCustomLocation" class="form-control" name="zip" placeholder="Zip Code" pattern="[0-9]{5}" title="Input must be 5 digits" required/>
              </div>

            </div>
            <div class="form-group-row" style = "display:'none'" name="locnamediv">
              <label for="">Location Name</label>
              <input type="text" onkeyup="forceDropdownCustomLocation" class="form-control" name="locname" style="width: 50%" placeholder="Give your new location a name!" required/>
            </div>
          </div>
          <div class="form-group row">
            <label for="timeNeeded">When will you be able to return it?</label><br/>
            <input type="date" class="form-control" id="datePicker" name="timeNeeded" style="width:20%; margin:0% auto" required/>
          </div>
          <div class="form-group row">
            <label for="urgent">This is an urgent request</label>
            <input type = "checkbox" name = "checkboxes" value="urgent"><br>
            <label for="urgent">This is a permanent loan</label>
            <input type = "checkbox" name = "checkboxes" value = "perm">
          </div>
          <button type="submit" class="btn btn-primary" id = "Submit" name="Submit">Submit</button><img id = "load" src = "../imgs/loader.gif" style = "visibility: hidden; margin-left: 15px;"> 
        </form>
      </div>

    </div>
  </div>

  <div class="col-sm-3 col-md-2 sidebar">
    <ul class="nav nav-sidebar">
      <h4>Shopping Cart Options</h4>
      <li class = "option" id = "os"><a href="#">Order Selected</a></li>
      <li class = "option" id = "ds"><a href="#">Remove Selected From Cart</a></li>
      <li class = "option" id = "oa"><a href="#">Order All</a></li>
      <li class = "option" id = "da"><a href="#">Remove All From Cart</a></li>
    </ul>
  </div>

  <div class = "displayDevice">
    <h2>Welcome to your shopping cart!</h2>
    <div id="shoppingContainer">
    </div>
  </div>

  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>
  <script src = "../javascript/nhpup_1.1.js"></script>
  <script type="text/javascript">
// adding event listeners to all the options, such as ordering and deleting
document.getElementById('os').addEventListener('click',orderSelected_showPopup);
document.getElementById('ds').addEventListener('click',deleteSelected);
document.getElementById('oa').addEventListener('click',orderAll_showPopup);
document.getElementById('da').addEventListener('click',deleteAll);

// Event listeners for order form address fields, to force select New Location if a field is changed
document.orderForm.address.addEventListener('keyup',forceDropdownCustomLocation);
document.orderForm.town.addEventListener('keyup',forceDropdownCustomLocation);
document.orderForm.state.addEventListener('keyup',forceDropdownCustomLocation);
document.orderForm.zip.addEventListener('keyup',forceDropdownCustomLocation);

document.onkeydown = function(e) {
  if (e.keyCode == 27) { 
    hidePopup();
  } 

}

window.onclick = function(event) { 
  var modal = document.getElementById('orderInfoModal');
  if(event.target == modal) modal.style.display = "none"; 
}
// Shipping form popup---------------------
var orderForm = document.getElementById('orderInfoModal');
var orderFormCloseButton = document.getElementById('closeOrderForm');
orderFormCloseButton.addEventListener('click',hidePopup);
// done applying event listeners
document.getElementById('datePicker').valueAsDate = new Date();

var employee = {
  id:"",
  location:"",
  name:"",
  phone:""
}
var checked = new Array();
var locations = getLocations();

var cart = getCartItems();
show();                                                                                 //on load, we want to show everything


function getCartItems(){
    var cart = new Array;                           //initiate array for them
    var cart_str = localStorage.getItem('cart');    //get them from local storage
    if (cart_str !== null) {                        //if there is at least one object already we need to convert it from JSON to string
      cart = JSON.parse(cart_str); 
    }
    return cart;                                    //return value is an array
  }

// Sets cart in localstorage to stringified parameter
function setCart(cartArray) {
  localStorage.setItem('cart',JSON.stringify(cartArray));
}

/**
This function displays a list of devices that a user has currently in their shopping cart.
**/
function show(){
    cart = getCartItems();                                              //get all the cart items you want to show
    var html = '';                                                          //html string initially empty
    var part1 = "nhpup.popup('";
    var part2 = "');"
    if(cart.length !== 0){                                                  //only continue if there are cart items
      html += '<p>Tickets have been generated below based on your desired selections.</p><br>'
        for(var i = 0; i < cart.length; i++){                               //iterate cart
            var id = cart[i].id;                                            //this gets the id value from the cart
                    html += '<div> <input class = "deviceCheckbox" type = "checkbox" id = "' + id + '"> </input><a class = "divlink" href = "#" onmouseover = "'+ part1 + 'Hardware type: ' + cart[i].hardware + '<br><br>' + cart[i].description + part2 + '"><div id = "ticket' + id +'" class = "ticket"><p class = "tickettext">' + cart[i].name + '</p></div></a></div>'; //create listing of all the devices
                  }
                }
    else{                                                                   //no point in doing all that computing if the list is empty
        html += 'Shopping cart is empty.';                                  //so give a nice error message.
      }

    document.getElementById('shoppingContainer').innerHTML = html;          //adds what we just generated to the webpage

    var checkboxes = document.getElementsByClassName('deviceCheckbox');     //get all the checkboxes we just placed!
    for(var i = 0; i < checkboxes.length; i++){                             //iterate them
        checkboxes[i].addEventListener('click',changeStatus);               //when we click on a checkbox, it should add/remove the id from the selected array
      }

      var tickets = document.getElementsByClassName('ticket');
      for(var i = 0; i < tickets.length; i++){
        tickets[i].addEventListener('click',clickTicket);
      }
    }

/**
This allows a ticket click to do the same thing as clicking on the checkbox.
**/
function clickTicket(){
  var checkboxes = document.getElementsByClassName('deviceCheckbox');
  var id = this.getAttribute('id');
  id = parseInt(id.replace(/[^0-9\.]/g,''),10);
  if(document.getElementById(id).checked == true){
    document.getElementById(id).checked = false;
        for(var i = 0; i < checked.length; i++){                            //iterate checked array
            if(id == checked[i])                                            //find the right checkbox
                checked.splice(i,1);                                        //remove from the array
            }
          }
          else{
            document.getElementById(id).checked = true;
            checked.push(id);
          }
        }

/**
When a checkbox is clicked, either a device needs to be checked or unchecked in the shopping cart. This function handles JUST that.
**/
function changeStatus(){
    var id = this.getAttribute('id');                                       //get the checkbox's id
    if(this.checked == true){                                               //we just checked it off
        checked.push(id);                                                   //add item to the selected list
      }
    else{                                                                   //we just unchecked it
        for(var i = 0; i < checked.length; i++){                            //iterate checked array
            if(id == checked[i])                                            //find the right checkbox
                checked.splice(i,1);                                        //remove from the array
            }
          }
        }

// These functions just redirect button pressed to call the showPopup method with the appropriate parameter
function orderSelected_showPopup() {
  showPopup(false);
}
function orderAll_showPopup() {
  showPopup(true);
}
// Opens order form and calls autofill method. Parameter is actually a string, not a boolean, because it will be put into a text field. 
// It indicaties which button was used to call the method.
// If true, submitting the form will order everything in the cart. If false it only orders selected devices.
function showPopup(orderAllBool){
  if(checked.length==0 && !orderAllBool){
    $('#Submit').attr('disabled',true);
    $('#Submit').attr('title',"There aren't any devices selected to order!");
  }
  else{
    $('#Submit').attr('disabled',false);
    $('#Submit').removeAttr('title');
  }
  orderForm.style.display = "block";
  autoFillFields(orderAllBool);
}

// Exits order form without subitting anything. Should maintain values in each field until page reload
function hidePopup(){
  orderForm.style.display = "none";
}

// Populates orderform fields with database information
// Boolean parameter is applied to the hidden 'orderAll' field on the
// order form, which is read before submission to determine which devices to include
function autoFillFields(orderAllBool) {
    // get employee
    <%
    int sso = Integer.parseInt(navsso);
    User employee = EmployeeQueries.getEmployeeByID(sso);
    int locationID = employee.getLocation();
    String name = employee.getName();
    String phone = employee.getPhone();    
    String email = employee.getEmail();
    %>
    employee.name = "<%=name%>";
    employee.phone = "<%=phone%>";
    employee.email = "<%=email%>";
    document.orderForm.name.value=employee.name;
    document.orderForm.phone.value=employee.phone;
    document.orderForm.email.value=employee.email;
    // already got locations on page load, now populate dropdown and mark appropriate option selected
    document.orderForm.location_dropdown.innerHTML="<option value = 0>New Location...</option>";
    for (var i = 0; i < locations.length; i++) {
      document.orderForm.location_dropdown.innerHTML+=
      ("<option value = "+locations[i].id
        + (locations[i].id == "<%=locationID%>" ? " selected>" : ">")
        + locations[i].name
        +"</option>");
    }
    // and fill in the location sub-fieds
    forceUpdateLocationMetadata();
    // finally mark hidden orderAll field appropriately
    document.orderForm.orderAll.value=orderAllBool?"true":"false";

    // Also, this is where I'm going to restrict the date input to the future
    var dtToday = new Date();
    var month = dtToday.getMonth() + 1;
    var day = dtToday.getDate();
    var year = dtToday.getFullYear();
    if(month < 10)
      month = '0' + month.toString();
    if(day < 10)
      day = '0' + day.toString();
    var minDate = year + '-' + month + '-' + day;    
    document.orderForm.timeNeeded.min=minDate;
  }

// Set all the shipping fields to the database values correspoding to the location selected in the dropdown
function forceUpdateLocationMetadata() {
  var selectedLocID = document.orderForm.location_dropdown.options[document.orderForm.location_dropdown.selectedIndex].value;
  var selectedLocation;
  for (var i = locations.length - 1; i >= 0; i--) {
    if(locations[i].id==selectedLocID) selectedLocation=locations[i];
  }
    if(selectedLocID!=0)       //0 is the 'new location' option
    {
      document.orderForm.locname.value = selectedLocation.name;
      document.orderForm.address.value = selectedLocation.address;
      document.orderForm.town.value = selectedLocation.town;
      document.orderForm.state.value = selectedLocation.state;
      document.orderForm.zip.value = selectedLocation.zip;
        // if we're force updating metadata, it means we don't want the name to be editable
        document.getElementsByName("locnamediv")[0].style.display="none";
      }
    else document.getElementsByName("locnamediv")[0].style.display="initial"; //Should be editable with new location though

    
  }

  function forceDropdownCustomLocation() {
    document.orderForm.location_dropdown.selectedIndex=0;
    document.orderForm.locname.value="";
    document.getElementsByName("locnamediv")[0].style.display="initial"; //let user edit name since they're making new location
  }

  function getLocations() {
    <%
    Location[] loci = LocationQueries.getLocations(sso);
    %>
    var loci = new Array(<%=loci.length%>);
    <%
    for(int i = 0; i<loci.length; i++)
    {
      %>
      loci[<%=i%>]={
        id:<%=loci[i].getID()%>,
        name:"<%=loci[i].getName()%>",
        address:"<%=loci[i].getAddress()%>",
        town:"<%=loci[i].getTown()%>",
        state:"<%=loci[i].getState()%>",
        zip:"<%=loci[i].getZip()%>"
      };
      <%
    }
    %>
    return loci;
  }

  function submitOrderForm() {
    // This is called just before order form is submitted. In order for any database activity to occur,
    // we must first append the employees ID as well as the ids of whatever devices are selected.

    document.getElementById("load").style.visibility = 'visible';
    
    // First, employee id
    userID=getUserID();
    document.orderForm.userID.value=userID;
    // Now selected devices.
    if(document.orderForm.orderAll.value=="true")  //if the order form was opened using the order all button
      {selectAllDevices();}
    
    var selectedDeviceString=JSON.stringify(checked);
    document.orderForm.deviceIDs.value=selectedDeviceString;


    // Finally remove selected items from the cart
    deleteSelected(false);
    return true;
  }

/**
This function takes all the devices we selected and removes them from the shopping cart.
Prompt is a boolean.
**/
function deleteSelected() {deleteSelected(true);} //this should handle call from delete selected button
function deleteSelected(prompt){
  var confirmDelete = prompt ? confirm("Are you sure you'd like to remove the selected items from the cart?") : true

    if(confirmDelete){                                              //if they confirm
        for(var i = 0; i < checked.length; i++){                    //iterate all the checked off devices
            var id = checked[i];                                    //get the id of each device
            var cart = getCartItems();                              //get the cart
            for(var j = 0; j < cart.length; j++){                   //iterate cart
                if(cart[j].id == id){                               //match ids
                    cart.splice(j,1);                               //remove from the cart
                  }
                }
            localStorage.setItem('cart', JSON.stringify(cart));     //update local storage
          }
        checked = new Array;                                        //reset the checked array
        show();                                                     //reload the container
      }
    }

// Adds all ids to the checked array
function selectAllDevices() {
  var cart = getCartItems();
  var duplicate = false;
  for (var i = cart.length - 1; i >= 0; i--) {
    duplicate = false;
    for (var j = checked.length - 1; j >= 0; j--) {
      if(checked[j]==cart[i].id)
      {
        duplicate=true;
      }
    }
    if(!duplicate) checked.push(cart[i].id)
  }
}

/**
This function takes all devices in the shopping cart and deletes them.
**/
function deleteAll(){
  var response = confirm("Are you sure you'd like to empty your cart?");
    if(response == true){                                       //if they confirm
        cart = new Array;                                       //empty cart
        localStorage.setItem('cart',JSON.stringify(cart));      //update local storage
        checked = new Array;                                    //reset the checked off array
        show();                                                 //reload container
      }                                                   
    }

    function getUserID() {
      return <%=sso%>;
    }
    function function_name(argument) {
      // body...
    }

  </script>
</body>
</html>

</body>

</html>