<html lang="en">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
  <meta name="description" content="">
  <meta name="author" content="">

  <title>Innovation Hub</title>

  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
  <link rel = "stylesheet" type = "text/css" href = "../css/stylesheet.css">  
  <link rel = "shortcut icon" href = "../imgs/synchrony-financial-logo-dlpx_1.ico">

  <style>
      /* Always set the map height explicitly to define the size of the div
      * element that contains the map. */
      #map {
        height: 80%;
        width: 80%;
        margin:0 auto;
        border-style: solid;
        border-width: 20px;
      }

      h2{
        text-align: center;
        padding-bottom: 10px;
      }
      
      div.infoContainer{
        border: solid; 
        border-width: thin; 
        padding: 15px;
        background-color: #E9EAEB;
        display: inline-block;
        margin-bottom: 30px;
        margin-top: 25px;
        text-align: left;
      }
      
      div.imgContainer{
        display: inline-block; 
        text-align: center;
      }
      
      div.statDescription{
        display: inline-block; 
        width: 200px; 
        text-align: center; 
      }
    </style>

  </head>

  <body>

    <nav class="navbar navbar-inverse navbar-fixed-top" id = "navbaruniversal">
      <%@ include file="components/navbar.jsp"%>
    </nav>

    <h2>Distribution of Devices Nationwide</h2>

    <div id="map"></div>
    <script src="https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/markerclusterer.js">
    </script>
    <script async defer
    src="https://maps.googleapis.com/maps/api/js?key=AIzaSyCndOcexx4GAOGkRKBeK1E43u_sB9gjcaU&callback=initMap">
    </script>
    <h2>Device Availability Statistics</h2>
  <div style = "background-color: #94969A;">
  <div style = "display: inline-block; border-style: solid; border-width: 20px; margin: 0px 0px 0px 50px;" id="piechart"></div>
  <div style = "float: right; border-style: solid; border-width: 20px; margin: 0px 50px 0px 0px;" id="colchart"></div>
  <br><br>
  <div style = "display: inline-block; border-style: solid; border-width: 20px; margin: 0px 0px 0px 50px;" id="bartypechart"></div>
  <div style = "float: right; border-style: solid; border-width: 20px; margin: 0px 50px 0px 0px;" id="barmanuchart"></div>
  <br><br>
  <div style = "display: inline-block; border-style: solid; border-width: 20px; margin: 0px 0px 0px 50px;" id="pietypechart"></div>
  <div style = "float: right; border-style: solid; border-width: 20px; margin: 0px 50px 0px 0px;" id="piemanuchart"></div>
  <br><br>
  <div style = "text-align: center;">
  <div style = "" class = infoContainer id="stats"></div>
  </div>
  </div>
  <%@ include file="../javascript/statistics.jsp" %>
  </body>
</html>
