<%@ page import = "database.*,entities.Location" %>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
    pageEncoding="ISO-8859-1"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
  <meta name="description" content="">
  <meta name="author" content="">

  <title>Innovation Hub</title>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
  <!-- Latest compiled and minified CSS -->
  <link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/bootstrap-table/1.11.1/bootstrap-table.min.css">
  <!-- Latest compiled and minified JavaScript -->
  <script src="//cdnjs.cloudflare.com/ajax/libs/bootstrap-table/1.11.1/bootstrap-table.min.js"></script>
  <!-- Latest compiled and minified Locales -->
  <script src="//cdnjs.cloudflare.com/ajax/libs/bootstrap-table/1.11.1/locale/bootstrap-table-zh-CN.min.js"></script>
  <link rel = "stylesheet" type = "text/css" href = "../../css/stylesheet.css">
  <link rel = "shortcut icon" href = "../../imgs/synchrony-financial-logo-dlpx_1.ico">
  <script async defer
    src="https://maps.googleapis.com/maps/api/js?key=AIzaSyCndOcexx4GAOGkRKBeK1E43u_sB9gjcaU">
    </script>
  <style>

    .form-control{
      margin: auto;
      text-align: center;
    }

    tr.entry{
      cursor: pointer;
    }

    .table{
      width: auto;
      background-color: #E9EAEB;
    }

    tbody{
      text-align: left;
    }
    
    body{
		overflow: visible;
	}
	
	div.displayDevice{
		padding-right: 30px;
		padding-bottom: 30px;
	}
  </style>
  <!-- Header -->
  <nav class="navbar navbar-inverse navbar-fixed-top" id = "navbaruniversal">
    <%@ include file="../components/adminnavbar.jsp"%>
  </nav>
</head>
<body>
  <!-- Side bar -->
  <div class="col-sm-3 col-md-2 sidebar">
	<%@ include file="../components/adminsidebar.jsp" %>
  </div>

  <!-- Modal for adding new location. -->
  <div id="addModal" class="modal">
        <div class="modal-content">
            <div class="modal-head">
                <span id="closeAddForm" class="close">&times;</span>
                <h4>Add a New Location Below</h4>
            </div><br>
            <div class="modal-body">
              <!-- Where new information is added. -->
              <form ACTION = "../redirect/locationRedirect.jsp" METHOD = "POST">
                <div class = "form-group">
                    <label for="addName">Location Name *</label>
                    <input style = "width: 150px;" name = "name" class="form-control" id="addName" placeholder="Location Name" required = "true">
                </div>
                <div class = "form-group">
                    <label for="addAddress">Address *</label>
                    <input style = "width: 200px;" name = "address" class="form-control" id="addAddress" placeholder="Address" required = "true">
                </div>
                <div class = "form-group">
                    <label for="addTown">City/Town *</label>
                    <input style = "width: 120px;" name = "town" class="form-control" id="addTown" placeholder="City/Town" required = "true">
                </div>
                <div class = "form-group">
                    <label for="addState">State *</label>
                    <select id = "addState" required style = "width: 150px;" name = "state" class="form-control">
                      <option value="" disabled selected>Choose State</option>
                      <option value="AL">Alabama</option>
                      <option value="AK">Alaska</option>
                      <option value="AZ">Arizona</option>
                      <option value="AR">Arkansas</option>
                      <option value="CA">California</option>
                      <option value="CO">Colorado</option>
                      <option value="CT">Connecticut</option>
                      <option value="DE">Delaware</option>
                      <option value="DC">District Of Columbia</option>
                      <option value="FL">Florida</option>
                      <option value="GA">Georgia</option>
                      <option value="HI">Hawaii</option>
                      <option value="ID">Idaho</option>
                      <option value="IL">Illinois</option>
                      <option value="IN">Indiana</option>
                      <option value="IA">Iowa</option>
                      <option value="KS">Kansas</option>
                      <option value="KY">Kentucky</option>
                      <option value="LA">Louisiana</option>
                      <option value="ME">Maine</option>
                      <option value="MD">Maryland</option>
                      <option value="MA">Massachusetts</option>
                      <option value="MI">Michigan</option>
                      <option value="MN">Minnesota</option>
                      <option value="MS">Mississippi</option>
                      <option value="MO">Missouri</option>
                      <option value="MT">Montana</option>
                      <option value="NE">Nebraska</option>
                      <option value="NV">Nevada</option>
                      <option value="NH">New Hampshire</option>
                      <option value="NJ">New Jersey</option>
                      <option value="NM">New Mexico</option>
                      <option value="NY">New York</option>
                      <option value="NC">North Carolina</option>
                      <option value="ND">North Dakota</option>
                      <option value="OH">Ohio</option>
                      <option value="OK">Oklahoma</option>
                      <option value="OR">Oregon</option>
                      <option value="PA">Pennsylvania</option>
                      <option value="RI">Rhode Island</option>
                      <option value="SC">South Carolina</option>
                      <option value="SD">South Dakota</option>
                      <option value="TN">Tennessee</option>
                      <option value="TX">Texas</option>
                      <option value="UT">Utah</option>
                      <option value="VT">Vermont</option>
                      <option value="VA">Virginia</option>
                      <option value="WA">Washington</option>
                      <option value="WV">West Virginia</option>
                      <option value="WI">Wisconsin</option>
                      <option value="WY">Wyoming</option>
                    </select>
                </div>
                <div class = "form-group">
                    <label for="addZip">Zip Code *</label>
                    <input style = "width: 100px;" name = "zip" type = "number" class="form-control" id="addZip" placeholder="Zip Code" required = "true">
                </div>
                <div class = "form-group">
                    <label for="addlat">Latitude</label>
                    <input style = "width: 150px;" type = "text" id = "addlat" class="form-control" name = "lat">
                </div>
                <div class = "form-group">
                    <label for="addlng">Longitude</label>
                    <input style = "width: 150px;" type = "text" id = "addlng" class="form-control" name = "lng">
                </div>
                <button id = "theaddbutton" type = "submit" name = "add" value = "Add" class="btn btn-primary">Add</button>
              </form>
            </div>
        </div>
  </div>
   
  <!-- Modal for modifying location. -->
  <div id="modifyModal" class="modal">
        <div class="modal-content">
            <div class="modal-head">
                <span id="closeModifyForm" class="close">&times;</span>
                <h4>Modify Location Below</h4>
            </div><br>
            <div class="modal-body">
              <!-- Where information is modified. -->
              <form ACTION = "../redirect/locationRedirect.jsp" METHOD = "POST">
                <div class = "form-group">
                    <label for="modifyName">Location Name *</label>
                    <input style = "width: 150px;" name = "name" class="form-control" id="modifyName" required = "true">
                    <span class = "help-block"></span>
                </div>
                <div class = "form-group">
                    <label for="modifyAddress">Address *</label>
                    <input style = "width: 200px;" name = "address" class="form-control" id="modifyAddress" required = "true">
                    <span class = "help-block"></span>
                </div>
                <div class = "form-group">
                    <label for="modifyTown">City/Town *</label>
                    <input style = "width: 120px;" name = "town" class="form-control" id="modifyTown" required = "true">
                </div>
                <div class = "form-group">
                    <label for="modifyState">State *</label>
                    <select required style = "width: 150px;" name = "state" class="form-control" id="modifyState">
                      <option value="" disabled selected>Choose State</option>
                      <option value="AL">Alabama</option>
                      <option value="AK">Alaska</option>
                      <option value="AZ">Arizona</option>
                      <option value="AR">Arkansas</option>
                      <option value="CA">California</option>
                      <option value="CO">Colorado</option>
                      <option value="CT">Connecticut</option>
                      <option value="DE">Delaware</option>
                      <option value="DC">District Of Columbia</option>
                      <option value="FL">Florida</option>
                      <option value="GA">Georgia</option>
                      <option value="HI">Hawaii</option>
                      <option value="ID">Idaho</option>
                      <option value="IL">Illinois</option>
                      <option value="IN">Indiana</option>
                      <option value="IA">Iowa</option>
                      <option value="KS">Kansas</option>
                      <option value="KY">Kentucky</option>
                      <option value="LA">Louisiana</option>
                      <option value="ME">Maine</option>
                      <option value="MD">Maryland</option>
                      <option value="MA">Massachusetts</option>
                      <option value="MI">Michigan</option>
                      <option value="MN">Minnesota</option>
                      <option value="MS">Mississippi</option>
                      <option value="MO">Missouri</option>
                      <option value="MT">Montana</option>
                      <option value="NE">Nebraska</option>
                      <option value="NV">Nevada</option>
                      <option value="NH">New Hampshire</option>
                      <option value="NJ">New Jersey</option>
                      <option value="NM">New Mexico</option>
                      <option value="NY">New York</option>
                      <option value="NC">North Carolina</option>
                      <option value="ND">North Dakota</option>
                      <option value="OH">Ohio</option>
                      <option value="OK">Oklahoma</option>
                      <option value="OR">Oregon</option>
                      <option value="PA">Pennsylvania</option>
                      <option value="RI">Rhode Island</option>
                      <option value="SC">South Carolina</option>
                      <option value="SD">South Dakota</option>
                      <option value="TN">Tennessee</option>
                      <option value="TX">Texas</option>
                      <option value="UT">Utah</option>
                      <option value="VT">Vermont</option>
                      <option value="VA">Virginia</option>
                      <option value="WA">Washington</option>
                      <option value="WV">West Virginia</option>
                      <option value="WI">Wisconsin</option>
                      <option value="WY">Wyoming</option>
                    </select>
                </div>
                <div class = "form-group">
                    <label for="modifyZip">Zip Code *</label>
                    <input style = "width: 100px;" name = "zip" type = "number" class="form-control" id="modifyZip" required = "true">
                </div>
                <div class = "form-group">
                    <label for="modifylat">Latitude</label>
                    <input style = "width: 150px;" type = "text" id = "modifylat" class="form-control" name = "lat">
                </div>
                <div class = "form-group">
                    <label for="modifylng">Longitude</label>
                    <input style = "width: 150px;" type = "text" id = "modifylng" class="form-control" name = "lng">
                </div>
                <button id = "themodifybutton" type = "submit" name = "modify" value = "Save Changes" class="btn btn-primary">Save Changes</button>
                <button id = "thedeletebutton" type = "submit" name = "delete" value = "Delete Entry" class="btn btn-primary" style = "display: inline-block;" title = "hello">Delete</button>
                <input type = "text" id = "modifyID" name = "id" style = "display: none;">
              </form>
            </div>
        </div>
  </div>
<!-- Body where locations are displayed -->
<div class = "displayDevice">
  <h2>Location Listing</h2>
	  <table id = "tabledisplay" class="table table-bordered table-hover" data-toggle="table" data-sort-name="name" data-sort-order="asc">
        <thead>
            <tr>
                <th data-name = "name" data-sortable = "true">Name</th>
                <th data-name = "add" data-sortable = "true">Address</th>
                <th data-name = "town" data-sortable = "true">Town</th>
                <th data-name = "st" data-sortable = "true">State</th>
                <th data-name = "zip" data-sortable = "true">Zip Code</th>
            </tr>
        </thead>
        <tbody id="tablebodymain">
        </tbody>
        </table>
  </table>
  <button id ="add" class="btn btn-primary">Add Location</button>
</div>
<%
//database query to get locations that all employees can access
Location[] locations = LocationQueries.getAdminLocations();
//string representation of array.
String locationString = Location.arrayToString(locations);
locationString = locationString.replace("'","\\'");
%>
<script type=text/javascript>

//JSON representation of array.
var locations = makeLocationArray();
//Populate locations into table!
populateLocations();

// geocode listeners
$("#addZip").keyup(geocodeTown);
$("#modifyZip").keyup(geocodeTown);
// adds event listeners to all table records
$("tr.entry").click(modifyModal);
// Exits modal when x is clicked.
$("#closeModifyForm").click(closeModifyModal);
// Open the add modal
$("#add").click(addModal);
// Event listener exits modal when x is clicked.
$("#closeAddForm").click(closeAddModal);
// Event listener exits modal when esc key pressed.
window.onkeydown = function(e){if (e.keyCode == 27){closeAddModal();closeModifyModal();}}
// Event listener exits modal when click outside modal.
window.onclick = function(e){var add = document.getElementById('addModal'); var modify = document.getElementById('modifyModal'); if(e.target == add || e.target == modify) {closeAddModal();closeModifyModal();}}

// Event listener for table records.	
$('#tabledisplay').bootstrapTable({onClickRow: function(row,$element){
  var id = $element[0].getAttribute('id');
  for(var i = 0; i < locations.length; i++){
  if(id == locations[i].id)
    break;
  }
  //autofill all information from what you clicked on into modal
  $("#modifyName").val(locations[i].name.replace(/&quot;/g,"\""));
  $("#modifyAddress").val(locations[i].address.replace(/&quot;/g,"\""));
  $("#modifyTown").val(locations[i].town.replace(/&quot;/g,"\""));
  $("#modifyState").val(locations[i].state);
  $("#modifyZip").val(locations[i].zip);
  $("#modifyID").val(locations[i].id);
  
  var geocoder =  new google.maps.Geocoder();
  //this function assumes that you are using a proper zip code...
  geocoder.geocode({'address':locations[i].zip}, function(results,status)
  	{if (status == google.maps.GeocoderStatus.OK)
		{$("#modifylat").val(results[0].geometry.location.lat());
		 $("#modifylng").val(results[0].geometry.location.lng());}
	});
  
  //if the location has a foreign key constraint, then the delete button should be restricted
  if(locations[i].numDevices > 0 || locations[i].numEmployees > 0){
  $('#thedeletebutton').attr('disabled',true);
  $('#thedeletebutton').attr('title','Cannot delete because devices and/or employees are at this location!');
  }
  else{
  $('#thedeletebutton').removeAttr('disabled');
  $('#thedeletebutton').removeAttr('title');
  }
  $("#modifyModal").show();
}});

//Places all locations from query into page
function populateLocations(){
  var html = "";
  for(var i = 0; i < locations.length; i++){
    html += "<tr class = 'entry' id = '" + locations[i].id + "'><td>" + locations[i].name + "</td><td>" + locations[i].address + "</td><td>" + locations[i].town + "</td><td>" + locations[i].state + "</td><td>" + locations[i].zip + "</td></tr>";
  }
  document.getElementById("tablebodymain").innerHTML = html;
}

//Make JSON from Java of retrieved devices.
function makeLocationArray(){
  window.json = '<%=locationString%>';
  return JSON.parse(window.json);
}

//open addModal
function addModal(){
  $("#addModal").show();
}

//close addModal
function closeAddModal(){
  $("#addModal").hide();
}

//open modifyModal
function modifyModal(){
  var id = this.getAttribute('id');
  for(var i = 0; i < locations.length; i++){
    if(id == locations[i].id)
      break;
  }
  //autofill all information from what you clicked on into modal
  $("#modifyName").val(locations[i].name.replace(/&quot;/g,"\""));
  $("#modifyAddress").val(locations[i].address.replace(/&quot;/g,"\""));
  $("#modifyTown").val(locations[i].town.replace(/&quot;/g,"\""));
  $("#modifyState").val(locations[i].state);
  $("#modifyZip").val(locations[i].zip);
  $("#modifyID").val(locations[i].id);
  
  var geocoder =  new google.maps.Geocoder();
  //this function assumes that you are using a proper zip code...
  geocoder.geocode({'address':locations[i].zip}, function(results,status)
  	{if (status == google.maps.GeocoderStatus.OK)
		{$("#modifylat").val(results[0].geometry.location.lat());
		 $("#modifylng").val(results[0].geometry.location.lng());}
	});
  
  //if the location has a foreign key constraint, then the delete button should be restricted
  if(locations[i].numDevices > 0 || locations[i].numEmployees > 0){
  $('#thedeletebutton').attr('disabled',true);
  $('#thedeletebutton').attr('title','Cannot delete because devices and/or employees are at this location!');
  }
  else{
  $('#thedeletebutton').attr('disabled',false);
  $('#thedeletebutton').removeAttr('title');
  }
  $("#modifyModal").show();
}

//close the modify modal
function closeModifyModal(){
  $("#modifyModal").hide();
}

//generate the lat & long of a location in real time!
function geocodeTown(){
	var id = this.getAttribute('id');
	var zip = $("#"+id).val();
	id = id.replace("Zip","");
	var geocoder =  new google.maps.Geocoder();
	//this function assumes that you are using a proper zip code...
	geocoder.geocode({'address':zip}, function(results,status)
		{if (status == google.maps.GeocoderStatus.OK)
			{$("#" + id + "lat").val(results[0].geometry.location.lat());
			 $("#" + id + "lng").val(results[0].geometry.location.lng());}
		});
	return true;
}

</script>
</body>
</html>