<%@ page import = "database.*,entities.*" %>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
    <meta name="description" content="">
    <meta name="author" content="">

    <title>Innovation Hub</title>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
    <link rel = "stylesheet" type = "text/css" href = "../css/stylesheet.css">
    <link rel = "shortcut icon" href = "../imgs/synchrony-financial-logo-dlpx_1.ico">
    <link rel="stylesheet" type="text/css" href="../javascript/iconselect.js-1.0/css/lib/control/iconselect.css" >
    <script type="text/javascript" src="../javascript/iconselect.js-1.0/lib/control/iconselect.js"></script>
    <script type="text/javascript" src="../javascript/iconselect.js-1.0/lib/iscroll.js"></script>

    <style>
        div.imageContainer{
            border: 5px solid;
            display: inline-block;  
            background-color: white;
            padding: 10px;
        }

        div.sidebar{
            width: 200px;
        }

        form.infobar{
            display: inline-block; 
            vertical-align: top;
            border: 5px solid;
            background-color: white;
            padding: 10px;
            padding-top: 0px;
            margin-left: 15px;
            width: 400px;
        }

        div.inputelement{
            padding: 5px;
        }

        div.inputelement input{
            border-width: solid;
        }

        body, html{
            overflow: hidden;
        }
    </style>

</head>

<body>
    <!-- Header. -->
    <nav class="navbar navbar-inverse navbar-fixed-top" id = "navbaruniversal">
        <%@ include file="components/navbar.jsp"%>
    </nav>
    <%
    User self = EmployeeQueries.getEmployeeByID(Integer.parseInt(navsso));
    %>
    <!-- Sidebar -->
    <div class="col-sm-3 col-md-2 sidebar">
      <ul class="nav nav-sidebar">
        <h4>User Profile Settings</h4>
        <li class = "option" id = "os"><a href="#">Profile Settings</a></li>
        <li class = "option" id = "ds"><a href="#">Location Settings</a></li>
        <li class = "option" id="ns"><a href="#">Notification Settings</a></li>
    </ul>
</div>

<!-- Popup to indicate info is missing -->
<div class = "modal" id = "missingcontent">
    <div class = "modal-content">
        <div class = "modal-head">
            <span id="closeBttn" class="close">&times;</span>
        </div>
        <div class = "modal-body">
            You need to edit some fields still.
        </div>
    </div>
</div>

<!-- Profile Settings -->
<div class = "profileContainer">
    <div style = "display: inline-block;">
        <!-- Where profile image gets edited -->
        <div class = "imageContainer">
            <img id = "profimg">
        </div>
        <br>
        <p style = "display: inline-block;">Change profile image:</p>
        <!--  Image selector tool -->
        <div id="my-icon-select" style = "display: inline-block;"></div>
    </div>
    <!-- Where main user information is edited -->
    <form action = "redirect/profileSettingsRedirect.jsp" class = "infobar">
        <h2>Profile Settings</h2>
        <div class = "form-group">
            <label for="inputName">Full Name *</label>
            <input name = "name" style = "width: 350px;" type = "name" class="form-control" id="inputName" placeholder="Name" required = "true">
            <span class = "help-block"></span>
        </div>
        <div class = "form-group">
            <label for="inputSSO">SSO Number *</label>
            <input name = "sso" readonly style = "width: 100px;" type = "id" class="form-control" id="inputSSO" placeholder="SSO #" required = "true">
            <span class = "help-block"></span>
        </div>
        <div class = "form-group">
            <label for="inputTelephone">Telephone Number</label>
            <input name = "phone" style = "width: 120px;" type = "tel" class="form-control" id="inputTelephone" placeholder="Telephone #">
        </div>
        <div class = "form-group">
            <label for="inputEmail">Email</label>
            <input name = "email" style = "width: 350px;" type = "email" class="form-control" id="inputEmail" placeholder="Email">
        </div>
        <input id = "hiddenIMG" style = "display: none" name = "img">
        <button name = "profile" type="submit" class="btn btn-primary" id = "applyProfile">Apply Changes</button>
    </form>
</div>
<!-- Location Settings -->
<div class="locationContainer" style="visibility: hidden;">
    <form name = "locationForm" action="redirect/locationSettingsRedirect.jsp" class="infobar">
        <h2>Location Settings</h2>
        <div class="form-group">
            <label for="location_dropdown">Place to ship to</label><br/>
            <select class="form-control" name="location_dropdown" id="dropdown" onchange="forceUpdateLocationMetadata()" style="width:65%; max-height: 80%; text-align: center; vertical-align: center; align-items: center; display: block; position: relative; margin: 0% auto; text-align-last:center; padding:">
            </select>
        </div>

        <div class="form-group row" style="display: block; align-items: center;margin: 3% auto;">
            <div class="col-md-6" style="width:50%">
              <div class="form-group row">
                <label for="address">Street Address</label>                        
                <input type="text" onkeyup="forceDropdownCustomLocation" class="form-control" name="address" placeholder="Address" required/>
            </div>
            <div class="form-group row">
                <label for="town">City</label>                            
                <input type="text" onkeyup="forceDropdownCustomLocation" class="form-control" name="town" placeholder="City" required/>
            </div>
        </div>
        <div class="col-md-6" style="width:50%">
          <div class="form-group row">
            <label for="state">State</label>                            
            <select required style = "width: 60%; text-align-last:center;" name = "state" class="form-control">
              <option value="" disabled selected>Choose State</option>
              <option value="AL">Alabama</option>
              <option value="AK">Alaska</option>
              <option value="AZ">Arizona</option>
              <option value="AR">Arkansas</option>
              <option value="CA">California</option>
              <option value="CO">Colorado</option>
              <option value="CT">Connecticut</option>
              <option value="DE">Delaware</option>
              <option value="DC">District Of Columbia</option>
              <option value="FL">Florida</option>
              <option value="GA">Georgia</option>
              <option value="HI">Hawaii</option>
              <option value="ID">Idaho</option>
              <option value="IL">Illinois</option>
              <option value="IN">Indiana</option>
              <option value="IA">Iowa</option>
              <option value="KS">Kansas</option>
              <option value="KY">Kentucky</option>
              <option value="LA">Louisiana</option>
              <option value="ME">Maine</option>
              <option value="MD">Maryland</option>
              <option value="MA">Massachusetts</option>
              <option value="MI">Michigan</option>
              <option value="MN">Minnesota</option>
              <option value="MS">Mississippi</option>
              <option value="MO">Missouri</option>
              <option value="MT">Montana</option>
              <option value="NE">Nebraska</option>
              <option value="NV">Nevada</option>
              <option value="NH">New Hampshire</option>
              <option value="NJ">New Jersey</option>
              <option value="NM">New Mexico</option>
              <option value="NY">New York</option>
              <option value="NC">North Carolina</option>
              <option value="ND">North Dakota</option>
              <option value="OH">Ohio</option>
              <option value="OK">Oklahoma</option>
              <option value="OR">Oregon</option>
              <option value="PA">Pennsylvania</option>
              <option value="RI">Rhode Island</option>
              <option value="SC">South Carolina</option>
              <option value="SD">South Dakota</option>
              <option value="TN">Tennessee</option>
              <option value="TX">Texas</option>
              <option value="UT">Utah</option>
              <option value="VT">Vermont</option>
              <option value="VA">Virginia</option>
              <option value="WA">Washington</option>
              <option value="WV">West Virginia</option>
              <option value="WI">Wisconsin</option>
              <option value="WY">Wyoming</option>
          </select>
      </div>
      <div class="form-group row">
        <label for="zip">Zip</label>                            
        <input id = "zip" type="text" onkeyup="forceDropdownCustomLocation" class="form-control" name="zip" placeholder="Zip Code" pattern="[0-9]{5}" title="Input must be 5 digits" required/>
    </div>

</div>
<div class="form-group-row" style = "display:'none'" name="locnamediv">
  <label for="">Location Name</label>
  <input type="text" onkeyup="forceDropdownCustomLocation" class="form-control" name="locname" style="width: 50%" placeholder="Give your new location a name!" required/>
</div>
</div>
<button type="submit" class="btn btn-primary" id = "Submit" name="Submit">Set default location</button><img id = "load" src = "../imgs/loader.gif" style = "visibility: hidden; margin-left: 15px;">
</form>
</div>
<!-- Notification Settings -->
<div class = "notificationContainer" style = "visibility: hidden;">
    <!-- Where main user information is edited -->
    <form name="notificationForm" onsubmit="return applyNotifiationChanges()" action = "redirect/notificationSettingsRedirect.jsp" class = "infobar"  method="post">
        <h2>Email Notification Settings</h2>
        <br>
        <h4>Send me a messege when...</h4>
        <div style="display: inline;">
            <input name="prefferedNotificationInteger" style="display: none;">
            <input name="user" style="display: none;" value=<%=navsso%>>
            <div style="float: left; margin-right: 10px;"><h5>Tickets are generated</h5></div>
            <div style="float: right;">
                <label class="switch">
                    <input type="checkbox" id="notificationSlider1">
                    <div class="slider round"></div>
                </label>
            </div><br><br>
            <div style="float: left; margin-right: 10px;"><h5>Ticket is approved</h5></div>
            <div style="float: right;">
                <label class="switch">
                    <input type="checkbox" id="notificationSlider2">
                    <div class="slider round"></div>
                </label>
            </div>
        </div><br><br>
        <div style="float: left; margin-right: 10px;"><h5>Ticket is rejected</h5></div>
        <div style="float: right;">
            <label class="switch">
                <input type="checkbox" id="notificationSlider3">
                <div class="slider round"></div>
            </label>
        </div><br><br><br>
        <div id = "adminNotificationContainer">
            <h2>Admin Emails</h2>
            <br>
            <div style="float: left; margin-right: 10px;"><h5>Send me daily summaries<br> of unaddressed client activity</h5></div>
            <div style="float: right;">
                <label class="switch">
                  <input type="checkbox" id="adminNotificationSlider">
                  <div class="slider round"></div>
              </label>
          </div>
      </div><br><br><br>
      <div style="text-align: center;">
        <button name = "notification" type="submit" class="btn btn-primary">Apply Changes</button>
        <button name="leaveMeAlone" class="btn btn-primary" style="background-color: red">Please just leave me alone</button>
    </div>
</form>
</div>


<script>

	var iconSelect;

    window.onload = function(){

        iconSelect = new IconSelect("my-icon-select", 
            {'selectedIconWidth':23,
            'selectedIconHeight':23,
            'selectedBoxPadding':3,
            'iconsWidth':48,
            'iconsHeight':48,
            'boxIconSpace':5,
            'vectoralIconNumber':2,
            'horizontalIconNumber':8});

        var icons = [];
        icons.push({'iconFilePath':'../imgs/my-icons-collection-32px/png/' + <%=self.getIcon()%> + '.png', 'iconValue':' + <%=self.getIcon()%> + '});
        for(var i = 1; i <= 15; i++){
            if( i != <%=self.getIcon()%>)
                icons.push({'iconFilePath':'../imgs/my-icons-collection-32px/png/' + i + '.png', 'iconValue':  i });
        }

        iconSelect.refresh(icons);

            //around here is where you'll have to define the current image, then this will update as the user selects new ones!
            $('#profimg').attr("src","../imgs/my-icons-collection-128px/png/" + '<%=self.getIcon()%>' + ".png");
            $('#hiddenIMG').val(<%=self.getIcon()%>);
        };
    //Listenress for sidebar options
    document.getElementById('os').addEventListener('click',focusOnProfile);
    document.getElementById('ns').addEventListener('click',focusOnNotifications);
    document.getElementById('ds').addEventListener('click',focusOnLocation);
    //Listeners for profile ssettings
    document.getElementById('applyProfile').addEventListener('click',applyProfileChanges);
    document.getElementById('inputName').addEventListener('keyup',checkEmpty);
    document.getElementById('inputSSO').addEventListener('keyup',checkEmpty);
    document.getElementById('closeBttn').addEventListener('click',function(){document.getElementById('missingcontent').style.display = "none";});
    // Listeners for notification settings
    document.getElementsByName('leaveMeAlone')[0].addEventListener('click',disableAllNotifications);

    var typeTimer;
	var doneTypingInterval = 2000 //ms
	
	$('#inputSSO').keyup(function(){clearTimeout(typeTimer); typeTimer = setTimeout(querySSO,doneTypingInterval);});
	
	var flag = 0;
	var name;
	var SSO;
	var telephone;
	var email;
	var locations=getLocations();
	//populates the fields
	populate();
	
    function focusOnProfile() {
        document.getElementsByClassName('profileContainer')[0].style.visibility='visible';
        document.getElementsByClassName('locationContainer')[0].style.visibility='hidden';
        document.getElementsByClassName('notificationContainer')[0].style.visibility='hidden';
    }
    function focusOnNotifications() {
        document.getElementsByClassName('notificationContainer')[0].style.visibility='visible';
        document.getElementsByClassName('locationContainer')[0].style.visibility='hidden';
        document.getElementsByClassName('profileContainer')[0].style.visibility='hidden';
    }
    function focusOnLocation() {
        document.getElementsByClassName('profileContainer')[0].style.visibility='hidden';
        document.getElementsByClassName('locationContainer')[0].style.visibility='visible';
        document.getElementsByClassName('notificationContainer')[0].style.visibility='hidden';
    }
	//sends applied changes to DB
	function applyProfileChanges(){
		if(flag == 0){
          name = $('#inputName').val();
          SSO = $('#inputSSO').val();
          telephone = $('#inputTelephone').val();
          email = $('#inputEmail').val();

		//send these values to DB for updates to be made
		//EX
			//if(name != "")
				//send to database
          }

          else
             $('#missingcontent').css('display','block');
     }
     function applyNotifiationChanges(){
        // Here is how the notification preferences integer works:
        // Begin by converting to binary.
        // First (least significant) bit:   Ticket generation/order received email
        // Second bit:      Ticket approved email
        // Third bit:       Ticket rejected email

        // If more email situations come up they can correspond to the fourth bit, fifth bit, etc.
        // 1 means send email; 0 means do not send email

        // This means determining what to set the new preference integer to is simply a matter of binary addition.
        var bit1 = document.getElementById('notificationSlider1').checked ? 1 : 0;
        var bit2 = document.getElementById('notificationSlider2').checked ? 1 : 0;
        var bit3 = document.getElementById('notificationSlider3').checked ? 1 : 0;
        var bit4 = document.getElementById('adminNotificationSlider').checked ? 1 : 0;
        var newNotificationPreferenceInteger = 1*bit1 + 2*bit2 + 4*bit3 + 8*bit4;
        document.notificationForm.prefferedNotificationInteger.value=newNotificationPreferenceInteger;
        return true;
    }
	//populates form fields if info exists in db already
	function populate(){
		//get values from database
        // Populationg profile settings
        $('#inputName').val('<%=navname%>');
        $('#inputSSO').val('<%=self.getID()%>');
        $('#inputTelephone').val('<%=self.getPhone()%>');
        $('#inputEmail').val('<%=self.getEmail()%>');
        // -----------------Pupulating location settings-----------------
        document.locationForm.location_dropdown.innerHTML="<option value = 0>New Location...</option>";

        for (var i = 0; i < locations.length; i++) {
          document.locationForm.location_dropdown.innerHTML+=
          ("<option value = "+locations[i].id
            + (locations[i].id == "<%=self.getLocation()%>" ? " selected>" : ">")
            + locations[i].name
            +"</option>");
        }
        forceUpdateLocationMetadata();
        // -----------------Populating notification settings------------
        if(<%=admin%>==1) //This should be defined in navbar/adminnavbar
        {
            document.getElementById("adminNotificationContainer").style="display:default";
        }
        else
        {
            document.getElementById("adminNotificationContainer").style="display:none";
        }
        // The notificationPreferences integer is explained in the applyNotifiationChanges() function above ^
        var NotificationPreferenceInteger='<%=self.getNotificationPreferences()%>';
        var bit1 = (NotificationPreferenceInteger)%2!=0;
        var bit2 = (NotificationPreferenceInteger>>1)%2!=0;
        var bit3 = (NotificationPreferenceInteger>>2)%2!=0;
        var bit4 = (NotificationPreferenceInteger>>3)%2!=0;
        document.getElementById("notificationSlider1").checked = (bit1==1);
        document.getElementById("notificationSlider2").checked = (bit2==1);
        document.getElementById("notificationSlider3").checked = (bit3==1);
        document.getElementById("adminNotificationSlider").checked = (bit4==1);
    }
    
    function checkEmpty(){
      var id = this.getAttribute('id');
      if($('#' + id).val() == ""){
       $('#' + id).parent().attr('class','form-group has-error');
       $('#' + id).siblings('span').text(warningtext(id))
   }
   else{
       $('#' + id).parent().attr('class','form-group');
       $('#' + id).siblings('span').text('')
   }

}

function warningtext(id){
  if(id == "inputName")
   return "This is a required field.";
else if (id == "inputSSO")
   return "This is a required field.";
}

function querySSO(){
		//query to see if SSO is in database already

		//if so... && val() != ""
		//$('#' + id).parent().attr('class','form-group has-error');
		//$('#inputSSO').siblings('span').text('SSO is currently in use.');
		//flag = 1;

		//if not... && val() != ""
		//$('#' + id).parent().attr('class','form-group');
		//$('#' + id).siblings('span').text('');
	}
	
	window.onclick = function(event) {
		var modal = document.getElementById('missingcontent');
		if(event.target == modal)
          modal.style.display = "none";
  }
  function disableAllNotifications() {
      document.notificationForm.prefferedNotificationInteger=0;
      document.getElementById("notificationSlider1").checked = false;
      document.getElementById("notificationSlider2").checked = false;
      document.getElementById("notificationSlider3").checked = false;
      document.getElementById("adminNotificationSlider").checked = false;
      document.notificationForm.submit();
  }
  function getLocations() {
    <%
    Location[] loci = LocationQueries.getLocations(Integer.parseInt(navsso));
    %>
    var loci = new Array(<%=loci.length%>);
    <%
    for(int i = 0; i<loci.length; i++)
    {
      %>
      loci[<%=i%>]={
        id:<%=loci[i].getID()%>,
        name:"<%=loci[i].getName()%>",
        address:"<%=loci[i].getAddress()%>",
        town:"<%=loci[i].getTown()%>",
        state:"<%=loci[i].getState()%>",
        zip:"<%=loci[i].getZip()%>"
      };
      <%
    }
    %>
    return loci;
  }
  // Set all the shipping fields to the database values correspoding to the location selected in the dropdown
function forceUpdateLocationMetadata() {
  var selectedLocID = document.locationForm.location_dropdown.options[document.locationForm.location_dropdown.selectedIndex].value;
  var selectedLocation;
  for (var i = locations.length - 1; i >= 0; i--) {
    if(locations[i].id==selectedLocID) selectedLocation=locations[i];
  }
    if(selectedLocID!=0)       //0 is the 'new location' option
    {
      document.locationForm.locname.value = selectedLocation.name;
      document.locationForm.address.value = selectedLocation.address;
      document.locationForm.town.value = selectedLocation.town;
      document.locationForm.state.value = selectedLocation.state;
      document.locationForm.zip.value = selectedLocation.zip;
        // if we're force updating metadata, it means we don't want the name to be editable
        document.getElementsByName("locnamediv")[0].style.display="none";
      }
    else document.getElementsByName("locnamediv")[0].style.display="initial"; //Should be editable with new location though

    
  }

  function forceDropdownCustomLocation() {
    document.locationForm.location_dropdown.selectedIndex=0;
    document.locationForm.locname.value="";
    document.getElementsByName("locnamediv")[0].style.display="initial"; //let user edit name since they're making new location
  }
</script>
</body>

</html>