<%@ page import = "database.*,entities.*" %>
<%@ page import = "java.util.Random" %>
<%@ page import = "database.*" %>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<%@ page import = "java.sql.*" %>
<%@ page import = "java.security.MessageDigest" %>
<%@ page import = "java.security.NoSuchAlgorithmException" %>
<%@ page import = "utilities.Mail" %>

<!DOCTYPE html>
<html>
<head>
<link rel = "stylesheet" type = "text/css" href = "../../css/stylesheet.css">
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
</head>
<body>

<script type="text/javascript">
<%

/*
	This handles the case where an admin is getting deleted.
*/
if(request.getParameter("delete") != null){
	int sso = Integer.parseInt(request.getParameter("AdminID"));
	AdminQueries.removeAdmin(sso);
}
/*
	This handles the case where an admin is getting added.
*/
if(request.getParameter("add") != null){
	int sso = Integer.parseInt(request.getParameter("adminID"));
	String email = request.getParameter("email");
	String name = request.getParameter("name");
	
	// Generate new password
	String alphabet = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	StringBuilder random = new StringBuilder();
	Random rnd = new Random();

	for (int i = 0; i < 16; i++) {
		int index = (int)(rnd.nextFloat()*alphabet.length());
		random.append(alphabet.charAt(index));
	}

	String password = random.toString();
	String hashpass = null;

	try {
		MessageDigest md = MessageDigest.getInstance("MD5");
		md.update(password.getBytes());
		byte[] bytes = md.digest();
		StringBuilder sb = new StringBuilder();
		for(int i = 0; i<bytes.length; i++)
			sb.append(Integer.toString((bytes[i] & 0xff) + 0x100, 16).substring(1));
		hashpass = sb.toString();
	}
	catch (NoSuchAlgorithmException e){
		
	}
	
	boolean exists = EmployeeQueries.employeeExists(sso);
	// If they exist as a current user already, just add them to the admin table
	if(exists){
		AdminQueries.addAdmin(sso,hashpass);
	}
	// If they do not exist as a current user at all, we add them as both
	else{
		EmployeeQueries.addEmployee(sso,1,name,"",email);
		AdminQueries.addAdmin(sso,hashpass);
	}
	
	// Dispatch email to new admin.
	User newadmin = EmployeeQueries.getEmployeeByID(sso);
	new Mail(newadmin).sendTemporaryPassword(password);
}
%>
window.location.replace("../administration/newadmin.jsp");
</script>
</body>
</html>