<%@ page import = "database.*" %>
<%@ page import = "utilities.NotificationQueue" %>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
    pageEncoding="ISO-8859-1"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
  <meta name="description" content="">
  <meta name="author" content="">

  <title>Synchrony Financial</title>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <link rel = "stylesheet" type = "text/css" href = "../../css/stylesheet.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
  <link rel = "shortcut icon" href = "../../imgs/synchrony-financial-logo-dlpx_1.ico">
  <nav class="navbar navbar-inverse navbar-fixed-top" id = "navbaruniversal">
    <%@ include file="../components/navbar.jsp"%>
  </nav>
</head>
<body>
<%
// Get form information.
String ticketidstr = request.getParameter("ticketid");
String deviceidstr = request.getParameter("deviceid");
String locationidstr = request.getParameter("locationid");
String permanent = request.getParameter("permField");
int ticketid = Integer.parseInt(ticketidstr);
int deviceid = Integer.parseInt(deviceidstr);
int locationid = Integer.parseInt(locationidstr);
int perm = permanent.equals("Yes") ? 1 : 0;

/*
	Approve ticket form was submitted.
*/
if(request.getParameter("approve") != null){
  // The location name that is being shipped is currently being stored in a temporary cookie.
  Cookie location = new Cookie("location",Integer.toString(locationid));
  location.setMaxAge(30*60);
  location.setPath("/");
  response.addCookie(location);
  
  // Accept the ticket
  TicketQueries.acceptTicket(ticketid,deviceid,locationid,Integer.parseInt(navsso),perm);
  
  // Dispatch email.
  User client = EmployeeQueries.getEmployeeByID(TicketQueries.getUserID(ticketid));
  boolean notificationPreferences = (Math.floor(client.getNotificationPreferences()>>1)%2==1);
  //The second least significant bit of notificationPreferences - the 2's place - is used for ticket approval notifications.
  if(notificationPreferences){
    NotificationQueue q = new NotificationQueue(client,"ticketConfirmations");
    q.start(); 
    response.sendRedirect("../administration/ticketApprove.jsp");
    return;
  }
}

/*
	Ticket reject form was submitted.
*/
if(request.getParameter("reject") != null){
  // Reject the ticket.
  TicketQueries.rejectTicket(ticketid);
  
  // Dispatch email.
  User client = EmployeeQueries.getEmployeeByID(TicketQueries.getUserID(ticketid));
  boolean notificationPreferences = (Math.floor(client.getNotificationPreferences()>>2)%2==1);
  //The third least significantbit of notificationPreferences - te 4's place - is used for ticket rejection notifications.
  if(notificationPreferences){
  NotificationQueue q = new NotificationQueue(client, "ticketRejections");
  q.start();
  response.sendRedirect("../administration/adminApprove.jsp");
  return;
  }
}
%>
</body>
</html>