<html lang="en">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
  <meta name="description" content="">
  <meta name="author" content="">

  <title>Innovation Hub</title>

  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
  <link rel = "stylesheet" type = "text/css" href = "../css/stylesheet.css">
  <link rel = "shortcut icon" href = "../imgs/synchrony-financial-logo-dlpx_1.ico">
  <style>
    div.deviceContainer{
      border: solid; 
      border-width: thin; 
      padding: 15px;
      background-color: #E9EAEB;
      display: inline-block;
    }

    div.imgContainer{
      display: inline-block; 
      text-align: center;
    }

    img.device{
      display: block;
    }

    div.deviceDescp{
      display: inline-block; 
      width: 200px; 
      text-align: center; 
    }

    button.requestbutton{
      display: block; 
      margin: auto;
    }

    div.cartConfirm{
      display: none;
      top: 50%;
      left: 50%;
      position: fixed;
      width: 155px;
      height: 85px;
      line-height: 85px;
      text-align: center;
      background-color: #FBC600;
      border: solid;
      border-color: #3B3C43;
      border-radius: 5px;
    }
    #pup{
      background-color: #E9EAEB;
      border: solid;
      text-align: center;
      padding: 10px;
    }
  </style>
</head>

<body>
  <nav class="navbar navbar-inverse navbar-fixed-top" id = "navbaruniversal">
    <%@ include file="components/navbar.jsp"%>
  </nav>
  <div class="col-sm-3 col-md-2 sidebar">
    <ul class="nav nav-sidebar">
      <h4>Hardware Type</h4>
      <li><label><input type="checkbox" class="hw-data-type" data-type = "Computer">  Computers</label></li>
      <li><label><input type="checkbox" class="hw-data-type" data-type = "Camera">  Cameras</label></li>
      <li><label><input type="checkbox" class="hw-data-type" data-type = "Smartphone">  Smartphone</label></li>
      <li><label><input type="checkbox" class="hw-data-type" data-type = "Storage Device">  Storage Devices</label></li>
      <li><label><input type="checkbox" class="hw-data-type" data-type = "Tablet">  Tablet</label></li>
      <li><label><input type="checkbox" class="hw-data-type" data-type = "Other">  Other</label></li> <!-- same -->
    </ul>
    <br>
    <ul class="nav nav-sidebar">
      <h4>Manufacture</h4>
      <li><label><input type="checkbox" class="sw-data-type" data-type = "Amazon">  Amazon</label></li>
      <li><label><input type="checkbox" class="sw-data-type" data-type = "Apple">  Apple</label></li>
      <li><label><input type="checkbox" class="sw-data-type" data-type = "Intel">  Intel</label></li>
      <li><label><input type="checkbox" class="sw-data-type" data-type = "Samsung">  Samsung</label></li>
      <li><label><input type="checkbox" class="sw-data-type" data-type = "Microsoft">  Microsoft</label></li>
      <li><label><input type="checkbox" class="sw-data-type" data-type = "Other">  Other</label></li> <!-- will modify later -->
    </ul>
  </div>

  <div class = "displayDevice">
    <h2>Available Devices
      <!-- I'm only using a form to leverage bootstrap's styling. The onsubmit function just returns false because the form is never meant to be submitted anywhere. -->
    </h2>
    <form onsubmit="return false;">
      <input type="search" class="form-control" name="searchBar" placeholder=" search for devices by name" autocomplete="off" style="width: 50%; text-align: left; margin: 1%;"  />
    </form>
    <div id = "devContainer"><p>Or choose an option to the left to begin requesting!</p></div>   
  </div>

  <div class = "cartConfirm" id = "added">
    <p>Added to Cart</p>
  </div>

  <div class = "cartConfirm" id = "already">
    <p>Already in Cart</p>
  </div>

  <%@ include file="../javascript/request.jsp" %>
</body>
</html>